
=== 1472NebraskaOverMesh-yo.cs ===
Change Set:		NebraskaOverMesh-yo
Date:			2 August 2007
Author:			Yoshiki Ohshima

This might be a wrong way to fix it, but this changeset makes the Nebraska work over olpc mesh.

=== 1471SugarNav13-yo.cs ===
Change Set:		SugarNav13-yo
Date:			28 July 2007
Author:			Yoshiki Ohshima

Update the buttons in the Sugar bar.

=== 1470notShowUpdateDir-yo.cs ===
Change Set:		notShowUpdateDir-yo
Date:			27 July 2007
Author:			Yoshiki Ohshima

Hide update directory from the project list.

=== 1469resumeFix-bf.cs ===

=== 1468datastore-bf.cs ===
Change Set:		datastore-bf
Date:			25 July 2007
Author:			Bert Freudenberg

Make resuming a project from datastore work (like after downloading a project). Also allow saving to and loading from datastore.

=== 1467DBus-Core-bf-34.cs ===
Change Set:		DBus-Core-bf-34
Date:			25 July 2007
Author:			Bert Freudenberg

Name: DBus-Core-bf.34
Author: bf
Time: 25 July 2007, 4:32:19 pm
UUID: 889fdb18-5739-4f01-8709-4f492d22abd2
Ancestors: DBus-Core-bf.33

- assign serial when sending message
- read replySerial in DBusMessageError
- add isReplyOrError

=== 1466SqueakToUtf8-ar.cs ===
Change Set:		SqueakToUtf8-ar
Date:			14 July 2007
Author:			Andreas Raab

Speed up conversion from and to UTF-8

=== 1465TransExportUI-tak.cs ===
Change Set:		TransExportUI-tak
Date:			23 July 2007
Author:			Takashi Yamamiya

Modify Language Editor UI for Korakurider's new
gettext exporter.

LanguageEditor openOnDefault.

To export template:
gettext - gettext template.

To export translation (split files):
gettext - gettext export

To import translation:
gettext -gettext import.

If you want to export as old style one translation file. Use workspace.
GetTextExporter new export: NaturalLanguageTranslator current.



=== 1464TransExport3-KR.cs ===
Change Set:		TransExport3-KR
Date:			23 July 2007
Author:			Korakurider

+ package pot by top-category of class excluding Morphic-*
+ export wordings and documentions (experimental) 

=== 1463relBuilderBinIcons-yo.cs ===
Change Set:		relBuilderCreateIcons-yo
Date:			19 July 2007
Author:			Yoshiki Ohshima

Release Builder creates icons.

=== 1462networkFix-mir-bf.cs ===
Change Set:		networkFix-mir-bf
Date:			19 July 2007
Author:			Michael Rueger, Bert Freudenberg

Fix non-blocking socket connection (mir).
Fix getting local host address (bf)

=== 1461helpTypo-sw.cs ===
Change Set:		helpTypo-sw
Date:			18 July 2007
Author:			Scott Wallace

Fixes a typo in the help msg for previous-arrow

=== 1460journalFix2-bf.cs ===
Change Set:		journalFix2-bf
Date:			18 July 2007
Author:			Bert Freudenberg

Use title from journal for project name, and vice versa

=== 1459journalFix-bf.cs ===
Change Set:		journalFix-bf
Date:			18 July 2007
Author:			Bert Freudenberg

Datastore object id must not be retained in image or project files

=== 1458avoidHelpFlap-sw.cs ===
Change Set:		avoidHelpFlap-sw
Date:			17 July 2007
Author:			Scott Walalce

Don't put up an event-theatre help flap at initialize time, but rather only when launching an event-theatre from a parts bin from a parts bin.  This avoids appearance of an unexpected evt-theatre help flap after a locale change.

Derived from Moshi update 0244avoidHelpFlap, but with a couple of methods stripped out.


=== 1457journal-bf.cs ===
Change Set:		journal-bf
Date:			17 July 2007
Author:			Bert Freudenberg

Datastore support part one: Create journal entries, update on deactivation, retrieve when resuming.

=== 1456FasterLocaleChange-yo.cs ===
Change Set:		FasterLocaleChange-yo
Date:			16 July 2007
Author:			Yoshiki Ohshima

Make locale change faster.

=== 1455SugarNav12-yo.cs ===
Change Set:		SugarNav12-yo
Date:			17 July 2007
Author:			Yoshiki Ohshima

Fix a one-off bug in the use of WarpBlt.  Also, fix the corrupted bitmaps.

=== 1454scriptorParam-sw.cs ===
Change Set:		scriptorParan-sw
Date:			13 July 2007
Author:			Scott Wallace

Fixes some problems in the headers of scriptors that have parameters.

=== 1453DBus-Core-bf-33.cs ===
Change Set:		DBus-Core-bf-33
Date:			16 July 2007
Author:			Bert Freudenberg

Name: DBus-Core-bf.33
Author: bf
Time: 16 July 2007, 6:50:05 pm
UUID: 6f230fd0-2cac-4fe5-abfc-ad232797cc81
Ancestors: DBus-Core-jaf.32

- fix writing of container types
- TODO: refactor Need type-specific DBusArg subclasses

=== 1452FixCopyMorph-tak.cs ===
Change Set:		FixCopyMorph-tak
Date:			14 July 2007
Author:			Takashi Yamamiya

Fix a problem that you cannot copy a morph on Windows nor Mac.

=== 1451ownerBuddy-bf.cs ===
Change Set:		ownerBuddy-bf
Date:			13 July 2007
Author:			Bert Freudenberg

Treat owner buddy specially: do not show in peer list, use  its nick as authorName

=== 1450TransExport2-KR.cs ===
Change Set:		TransExport2-KR
Date:			13 July 2007
Author:			Korakurider

merge duplicate msgid entry on export, and show each occurence as header for msgid

=== 1449WanderingLetters-tk.cs ===

=== 1448MouseOverHalosFix-tak.cs ===
Change Set:		MouseOverHalosFix-tak
Date:			12 July 2007
Author:			Takashi Yamamiya

Fixed a bug that mouse over halos need a double click.

=== 1447supressViewerNotice-yo.cs ===
Change Set:		supressViewerNotice-yo
Date:			12 July 2007
Author:			Yoshiki Ohshima

In non eToyFriendly mode, building viewer progress bar is suppressed.  (Also, #translated is added.)

=== 1446disablePutInWindow-yo.cs ===
Change Set:		disablePutInWindow-yo
Date:			12 July 2007
Author:			Yoshiki Ohshima

In eToyFriendly mode, disable put in a window feature.

=== 1445SugarNav11-yo.cs ===
Change Set:		SugarNav11-yo
Date:			12 July 2007
Author:			Yoshiki Ohshima

Replace quit button with stop button.

=== 1444CatalogEntriesJul12-yo.cs ===
Change Set:		CatalogEntriesJul12-yo
Date:			12 July 2007
Author:			Yoshiki Ohshima

Adjust some labels in object catalog.

=== 1443RemoveAtomicGame.cs ===
Change Set:		RemoveAtomicGame
Date:			12 July 2007
Author:			Yoshiki Ohshima

Remove AtomicGame from the system.

=== 1442TransExport1-KR.cs ===
Change Set:		TransExport1-KR
Date:			11 July 2007
Author:			Korakurider

Collect translated literals and extract them to gettext POT (prototype attempt).

GetTextExporter2 new export. 


=== 1441ExClipboardMorphic4-tak.cs ===
Change Set:		ExClipboardMorphic4-tak
Date:			11 July 2007
Author:			Takashi Yamamiya

Better behavior in Sugar environment.
- Fixed a bug that it happens to be copied 3 times to Sugar frame.
- Fixed a bug not to work dragging out on Sugar.


=== 1440HonorCursorChange-yo.cs ===
Change Set:		HonorCursorChange-yo
Date:			11 July 2007
Author:			Yoshiki Ohshima

biggerCursor preference change is informe to HandMorph and it reinitializes the class var.

=== 1439rotatedBareTileOops-sw.cs ===
Change Set:		rotatedBareTileOops-sw
Date:			11 July 2007
Author:			Scott Wallace

Fixes a glitch that caused the jump when grabbing a bare tile to appear again.

=== 1438DndOutMorphic-tak.cs ===
Change Set:		DndOutMorphic-tak
Date:			10 June 2007
Author:			Takashi Yamamiya

An immature attempt of dragging out.
It doesn't work on Sugar environment though, you can test
its basic DnD feature with two Squeak images with Squeak vm
in takashi-branch.

- Open two Squeak images.
- Create a morph.
- Drop the morph to another image.
- If the image is TextMorph or StringMorph, it is copied as a text.
  otherwise, as a png (SketchMorph).


=== 1437explicitlySetDisplay-yo.cs ===
Change Set:		explicitlySetDisplay-yo
Date:			10 July 2007
Author:			Yoshiki Ohshima

Upon release, we set display depth to 16 explicitly.

=== 1436VIrtDepthNativeDepth-yo.cs ===
Change Set:		VIrtDepthNativeDepth-yo
Date:			10 July 2007
Author:			Yoshiki Ohshima

The current OLPCVirtualDispaly stays in 32-bit mode.  This means that if a user authors a project in that mode on a non-OLPC computer, and load it to Etoys on XO, the display depth should not use it.  With this change, it uses the native display depth when saving.

=== 1435WSandCatalog-yo.cs ===
Change Set:		WSandCatalog-yo
Date:			9 July 2007
Author:			Yoshiki Ohshima

SpectrumAnalyzer gets bigger buttons.
SpectrumAnalyzer shows up in Multimedia category.
VideoMorph shows up as 'Camera'.
PhonePad is moved to Multimedia.
PhonePad gets better buttons.
WorldStethoscope is moved to Multimedia.
WorldStethoscope get bigger buttons.




=== 1434releaseForOLPC3-yo.cs ===
Change Set:		releaseForOLPC3-yo
Date:			5 July 2007
Author:			Yoshiki Ohshima

Tweak the release builder code again.

=== 1433SaveVideo-yo.cs ===
Change Set:		SaveVideo-yo
Date:			5 July 2007
Author:			Yoshiki Ohshima

VideoMorph can be saved into a project, and it pauses when the project switches.

=== 1432TRscalingOptions-yo.cs ===
Change Set:		TRscalingOptions-yo
Date:			5 July 2007
Author:			Yoshiki Ohshima

change the wording for English via translation.

=== 1431scalingChoice-yo.cs ===
Change Set:		scalingChoice-yo
Date:			5 July 2007
Author:			Yoshiki Ohshima

Enable translations for scaling options and helps

=== 1430KedamaPatchTiles-yo.cs ===

=== 1429bareTiles-sw.cs ===
Change Set:		bareTiles-sw
Date:			5 July 2007
Author:			Scott Wallace

Do not allow editing in tiles on the desktop.  Instead, any mouse down on such a tile basically just picks it up.  This is not 100% ideal, but better than the previous situation.

=== 1428caretIssues-sw.cs ===
Change Set:		caretIssues-sw
Date:			29 June 2007
Author:			Scott Wallace

Refactors the logic for adding/deleting/showing/hiding carets on tiles.

=== 1427kbdFocusInPhrase-sw.cs ===
Change Set:		kbdFocusInPhrase-sw
Date:			25 June 2007
Author:			Scott Wallace

Assure release of keyboard focus when user grabs a phrase tile.  Having kbd focus persist in such circumnstances had various adverse effects, which this fixes.

=== 1426FixScaledDrop-ar.cs ===
Change Set:		FixScaledDrop-ar
Date:			29 June 2007
Author:			Andreas Raab

Fixes a problem with DnD handling when scaling is on.

=== 1425simpleErase-sw.cs ===
Change Set:		simpleErase-sw
Date:			2 July 2007
Author:			Scott Wallace

Make the 'erase' and 'stamp & erase' tiles do simple deletion of the object, *not* putting it in the trash and *not* animating.

=== 1424tinyTweaks-sw.cs ===
Change Set:		tinyTweaks-sw
Date:			2 July 2007
Author:			Scott Wallace

Two adjustments as per Kim's memo fo 29 June:
*  Default clock does not show seconds.
*  'make this the template for new pages' wording change in 'advanced' book-morph submenu.

=== 1423scriptorMenu-sw.cs ===
Change Set:		scriptorMenu-sw
Date:			2 July 2007
Author:			Scott Wallace

Remove some redundancy between scriptor menu and gold-box, and harmonize the eToyFriendly and non-eToyFriendly variants of the scriptor menu.

=== 1422alignProjSorter-yo.cs ===
Change Set:		alignProjSorter-yo
Date:			29 June 2007
Author:			Yoshiki Ohshima

Align the sorter.
Add scroll bar to the project sorter when it is too big.

=== 1421viewerTabs-sw.cs ===
Change Set:		viewerTabs-sw
Date:			29 June 2007
Author:			Scott Wallace

When toggling the implicitSelfInTiles preference, assure that all the viewers represented by viewer-flap-tabs in the projects are fully instantiated.

=== 1420listenLoop-bf.cs ===
Change Set:		listenLoop-bf
Date:			29 June 2007
Author:			Bert Freudenberg / Michael Rueger

implement listening with new prims - default to IPv4 for now

=== 1419desktopKeys-bf.cs ===
Change Set:		desktopKeys-bf
Date:			29 June 2007
Author:			Bert Freudenberg

Enable desktop keys to make Ctrl-C work for copy

=== 1418CopyOnWorld-tak.cs ===
Change Set:		CopyOnWorld-tak
Date:			28 June 2007
Author:			Takashi Yamamiya

You can copy selected (halo-ed or grabbed) object with Ctrl + C. 

=== 1417swapCtrlAndAltKeys2-tak.cs ===
Change Set:		swapCtrlAndAltKeys2-tak
Date:			28 June 2007
Author:			Takashi Yamamiya

After exploring for a while, I realized the best way to handle modifier keys is simply switching Ctrl <-> Alt. Using KeyDecodeTable in InputSensor is interesting though, it makes very puzzled behavior. I'll remove redundant code after enough tests.

I recommend UI developers to switch the preference to:
Preferences enable: #swapControlAndAltKeys.

Bug: Ctrl-m doesn't work in some platform.


=== 1416releaseForOLPC2.cs ===
Change Set:		releaseForOLPC2
Date:			28 June 2007
Author:			Yoshiki Ohshima

Split 'prepare' and 'build' in the release process.

=== 1415completeCambridge-yo.cs ===
Change Set:		completeCambridge-yo
Date:			27 June 2007
Author:			Yoshiki Ohshima

Really sets all preferences.

=== 1414ExClipboardMorphic3-tak.cs ===
Change Set:		ExClipboardMorphic3-tak
Date:			28 June 2007
Author:			Takashi Yamamiya

Just a bug fix with 'copy into paste buffer'

=== 1413noHide-yo.cs ===
Change Set:		noHide-yo
Date:			27 June 2007
Author:			Yoshiki Ohshima

projectView won't dissapear.

=== 1412honorSuffix-yo.cs ===
Change Set:		honorSuffix-yo
Date:			27 June 2007
Author:			Yoshiki Ohshima

When looking for the best match, it also takes care of the suffix of filename.

=== 1411swapCtrlAltKeys-tak-yo.cs ===
Change Set:		swapCtrlAndAltKeys-tak-yo
Date:			27 June 2007
Author:			Takashi Yamamiya and Yoshiki Ohshima


After some conversation, we decided to handle this differently.  So, this reverts 1402swapCtrlAndAltKeys-tak.


=== 1410stickyDIalogs-yo.cs ===
Change Set:		stickyDIalogs-yo
Date:			27 June 2007
Author:			Yoshiki Ohshima

Make project saving/loading dialogs sticky.

=== 1409dropHtmlImg-bf.cs ===
Change Set:		dropHtmlImg-bf
Date:			27 June 2007
Author:			Bert Freudenberg

Download and show images embedded in pasted HTML.

=== 1408useOldNetwork-bf.cs ===
Change Set:		useOldNetwork-bf
Date:			27 June 2007
Author:			Bert Freudenberg

Use old socket primitives by default, that is, unless a new plugin is detected

=== 1407releaseForOLPC.cs ===
Change Set:		releaseForOLPC
Date:			27 June 2007
Author:			Yoshiki Ohshima

adjust releasebuilder for squeakland.

=== 1406ExClipboardMorphic2-tak.cs ===
Change Set:		ExClipboardMorphic2-tak
Date:			26 June 2007
Author:			Takashi Yamamiya

You can copy by Ctrl+v from whichever inside or outside Squeak.
- Clipboard and Morphic paste buffer is now integrated.
- A text from external clipboard works somewhat better.

todo:
Maybe Clipboard should handles a morph instead of PasteBuffer of HandMorph.

=== 1405biggerDefaultStar-sw.cs ===
Change Set:		biggerDefaultStar-sw
Date:			26 June 2007
Author:			Scott Wallace

Make the defauilt Star be larger.

=== 1404roundGoldBox-sw.cs ===
Change Set:		roundGoldBox-sw
Date:			25 June 2007
Author:			Scott Wallace

Try out Abe-san's round supplies-bin icon for the gold-box in a Scriptor.

=== 1403clickInPartsBin-sw.cs ===
Change Set:		clickInPartsBin-sw
Date:			26 June 2007
Author:			Scott Wallace

Our proposed solution to the click-in-parts-bin issue:  Whenever launching from a parts bin, attach the item to the hand at the top-left corner of the object.  This seems to work very well

=== 1402swapCtrlAndAltKeys-tak.cs ===
Change Set:		swapCtrlAndAltKeys-tak
Date:			26 June 2007
Author:			Takashi Yamamiya

It just enables swapControlAndAltKeys to see how it looks like...
http://lists.laptop.org/pipermail/etoys/2007-June/000632.html


=== 1401ip6-mir.cs ===
Change Set:		ip6-mir
Date:			26 June 2007
Author:			Michael Rueger, Ian Piumarta

Image support for IPv6, plus backwards-compatibilty code

=== 1400deleteListener-yo.cs ===
Change Set:		deleteListener-yo
Date:			26 June 2007
Author:			Yoshiki Ohshima

Clear listener when publishing.

=== 1399ExamplesFromGallery-yo.cs ===

=== 1398launcherWithGallery2-yo.cs ===
Change Set:		launcherWithGallery2-yo
Date:			26 June 2007
Author:			Yoshiki Ohshima

Use the Gallery project.

=== 1397launcherWithGallery-yo.cs ===
Change Set:		launcherWithGallery-yo
Date:			26 June 2007
Author:			Yoshiki Ohshima

Use the Gallery project.

=== 1396dbusSugarExt-bf.cs ===
Change Set:		dbusSugarExt-bf
Date:			26 June 2007
Author:			Bert Freudenberg

support launching via external factory service

=== 1395DBus-Core-jaf-32.cs ===
Change Set:		DBus-Core-jaf-32
Date:			26 June 2007
Author:			Bert Freudenberg

Latest DBus bindings
Name: DBus-Core-jaf.32
Author: jaf
Time: 31 May 2007, 11:52:13 pm
UUID: 046d455d-88e8-4c84-af23-f5d3f994b2cb


=== 1394functionWrapFix-sw.cs ===
Change Set:		functionWrapFix-sw
Date:			25 June 2007
Author:			Scott Wallace

Make the up-down carets on function tiles wrap as expected.

=== 1393functionTileFixes-sw.cs ===
Change Set:		functionTileFixes-sw
Date:			24 June 2007
Author:			Scott Wallace

Avoid walkback when trying to 'remove function' from a bare function tile on the desktop.
Rename sqrt to squareRoot.

=== 1392KedamaTestJun25-yo.cs ===
Change Set:		KedamaTestJun25-yo
Date:			25 June 2007
Author:			Yoshiki Ohshima

the data dependency logic was faulty.

=== 1391randomTile-sw.cs ===
Change Set:		randomTile-sw
Date:			25 June 2007
Author:			Scott Wallace

Remove the obsolete RandomNumberTile from the supplies flap.
Put a new-style Random tile, built on FunctionTile, in the scripting flap.


=== 1390recompilingFix2-yo.cs ===
Change Set:		recompilingFix2-yo
Date:			23 June 2007
Author:			Yoshiki Ohshima

Fix the timing of viewer update (again).  There should be a better theory.

=== 1389kedamaRandomFunction-yo.cs ===
Change Set:		kedamaRandomFunction-yo
Date:			22 June 2007
Author:			Yoshiki Ohshima

Kedama had a problem with function tile for random.

=== 1388flatterKedama2-yo.cs ===

=== 1387flatterKedama-yo.cs ===

=== 1386noCommentFromMethod-yo.cs ===
Change Set:		noCommentFromMethod-yo
Date:			23 June 2007
Author:			Yoshiki Ohshima

not try to fetch comments from method for balloonHelp.

=== 1385timesRepeatFixes-sw.cs ===
Change Set:		timesRepeatFixes-sw
Date:			23 June 2007
Author:			Scott Wallace

Avoid error when generating code for empty-Times-area case.
Avoid error when Times area evaluates to non-integer.
Note:  The obsolete TimesRepeatMorph also has its code-generating code fixed here.

=== 1384saferLogs-sw.cs ===
Change Set:		saferLogs-sw
Date:			22 June 2007
Author:			Scott Wallace

The 'safe' log/ln methods were not handling log 0, with the result that Infinity rather than an exception was being returned, which raises havoc with various attempts to use the value in arithmetic.

=== 1383recompilingFIx-yo.cs ===
Change Set:		recompilingFIx-yo
Date:			21 June 2007
Author:			Yoshiki Ohshima

This method is a temporary measure to ensure the project local References get in the compiled scripts.  (When compiled methods are recompiled via #compileAll, it is done in a ways that it ignores the environment.

=== 1382ScrtEditrFixJul20-yo.cs ===
Change Set:		ScrtEditrFixJul20-yo
Date:			20 June 2007
Author:			Yoshiki Ohshima

This makes me think that why the mechanism to generate ParseNode directly works, but this is the correct code.

=== 1381timesCarets-sw.cs ===
Change Set:		timesCarets-sw
Date:			15 June 2007
Author:			Scott Wallace

Makes the 'times' part of the Times-Repeat unit conducive to suffix arrow and retract-arrow use.

Because of the significant structure change, the new times-repeat tile is embodied in a new classs, TimesRepeatTile, as a replacement fot TimesRepeatMorph.  For the moment at least we leave the latter in place, unchanged, for backward compatibility, though this may turn out not to have been entirely wise.

=== 1380KedamaEncoderJun13-yo.cs ===
Change Set:		KedamaEncoderJun13-yo
Date:			13 June 2007
Author:			Yoshiki Ohshima

Fix Kedama compiler.

=== 1379PrecWithFlatten-yo.cs ===
Change Set:		PrecWithFlatten-yo
Date:			13 June 2007
Author:			Yoshiki Ohshima

This removes the restriction on the shape of morph tree on tiles.  Any tree for binary expressions is flattened first then goes through the precedence manipulation.

=== 1378PrecInFunction-yo.cs ===
Change Set:		PrecInFunction-yo
Date:			13 June 2007
Author:			Yoshiki Ohshima

Operator precedence in functions works.

=== 1377functionTiles-sw.cs ===
Change Set:		functionTiles-sw
Date:			20 2007
Author:			Scott Wallace

Adds Function Tiles to etoys.

Two ways to get a function tile:

(a)  Get a blank one from the gold box.  This will give you a function  tile with 'abs' pre-selected.  You can then choose a different call by clicking on the function tile -- see below.

(b)  If you already have an expression constructed as the argument of the desired function, which you don't want to lose, you can 'wrap' that expression in a function call by shift-clicking on the suffix (right-facing) caret to the right of the expression. 

Click on the function name to get a pop-up of function choices.  Or click on the up-and-down carets to the left of the function name to cycle through the available functions.  The function called 'group' in the pop-up, and shown as a blank on the tile, provides parenthesization of the argument without any actual function call.

After grabbing a new function tile from the gold box, drop it wherever a Number can be dropped.  

Whenever you are dragging a number-type tile over a place in an existing line of script where a number is expected, the thing which would be replaced by a drop at that moment is cleanly indicated by a bright green border.

If you have constructed an expression which you subsequently decide needs to be 'wrapped' in a function-call, you can achieve this by holding down the *shift* key as you click on the expression's extension-arrow.

The function alternatives include two special ones:  one for 'unwrapping' the function while not losing the argument, so that for example 'sin(sar's x + 1)' becomes 'car's x + 1', and the other, 'group', to assure that the expression within the parentheses is evaluated before being combined with surrounding tiles in a larger expression.

Scriptors also can choose to show or to suppress the little green carets on tiles.  For readability and economy of space, one may often wish to view the script without the carets.  For editing, one often will want to show the carets.

=== 1376prefMenuItem-sw.cs ===
Change Set:		prefMenuItem-sw
Date:			21 May 2007
Author:			Scott Wallace

Adds a simple way to add a checkbox governing a preference to a menu.

For example:

	| aMenu |
	aMenu := MenuMorph new defaultTarget: ScriptingSystem.
	aMenu add: 'beep' action: #beep.
	Preferences addCheckboxGoverning: #soundsEnabled toMenu: aMenu.
	aMenu openInWorld


=== 1375goldBox-sw.cs ===
Change Set:		goldBox-sw
Date:			20 June 2007
Author:			Scott Wallace

Replaces the test-yes-no item in the Scriptor header with a 'gold box' from whence not only test-yes-no but also other tiles formerly accessible only from the Scriptor's menu can be obtained.

=== 1374commentWorkaround-sw.cs ===
Change Set:		commentWorkaround-sw
Date:			25 May 2007
Author:			Scott Wallace

Provisional workaround for an issue that broke the 'check for uncommented methods' feature in any change set that has methods for classes that inherit from MMeta.

=== 1373cmdsFromScriptor-sw.cs ===
Change Set:		cmdsFromScriptor-sw
Date:			1 May 2007
Author:			Scott Wallace

Makes it possible from a Scriptor both to open the Viewer of the object to which the script belongs, and to reveal the owning object itself.

The ScriptEditorMorph menu change to invoke these items is in a different update...

=== 1372allPlayersTool-sw.cs ===
Change Set:		allPlayersTool-sw
Date:			25 May 2007
Author:			Scott Wallace

Make the list in an all-players tool be scrollable, and give a menu button back to each entry.  Make the tool auto-update.  New menu capability to force a new name on an object, even if another object currently bearing that name needs to be renamed.

=== 1371projThumbAvoidsBar-yo.cs ===
Change Set:		projThumbAvoidsBar-yo
Date:			20 June 2007
Author:			Yoshiki Ohshima

Project thumbnails avoid the Sugar bar.

=== 1370zoomButton-yo.cs ===
Change Set:		zoomButton-yo
Date:			20 June 2007
Author:			Yoshiki Ohshima

Delete the scaling button when it is unnecessary.

=== 1369updateInterval-yo.cs ===
Change Set:		updateInterval-yo
Date:			19 June 2007
Author:			Yoshiki Ohshima

Updating Morphs update themselves less often.

=== 1368mouseover-yo.cs ===
Change Set:		mouseover-yo
Date:			19 June 2007
Author:			Yoshiki Ohshima

Non-world PasteUps were too eager to put mouse over halos.

=== 1367OLPCVirtualSlide-yo.cs ===
Change Set:		OLPCVirtualSlide-yo
Date:			19 June 2007
Author:			Yoshiki Ohshima

BitBlt doesn't send the bits to framebuffer automatically when the destination is the OLPCVirtualScreen.

=== 1366SiblingScripts-tk.cs ===
Change Set:		SiblingScripts-tk
Date:			15 June 2007
Author:			Ted Kaehler

Convert (Player>>allScriptEditors) into a non-destructive method.  

Previously it set the scriptedPlayer of every ScriptEditorMorph to the receiver.  If a ScriptEditor was open on a sibling of the receiver, the scriptedPlayer was changed.  Bad when separate viewers and scriptEditors are open on two siblings.  Bad when ScriptEditors are open on pages of a book and need to show self as a specific sibling.

Previous destructive behavior occurred when a project was being saved (prepareToBeSaved), when a project was entered (finalEnterActions), or when a variable was renamed (noteRenameOf: oldSlotName to: newSlotName inPlayer: aPlayer).

makeAllScriptEditorsReferToMasters  really does want to be destuctive, so it does not call allScriptEditors anymore.

Note that methods hasScriptInvoking:ofPlayer: and hasScriptReferencing:ofPlayer: are ambiguous when there are siblings.  Perhaps the class should be sent in to be tested rather than a specific player?  Or, if refs to a specific sibling are wanted, both the instance and the class must be tested.  In any case, ScriptEditors should not be retargeted.  hasScriptInvoking:ofPlayer: and hasScriptReferencing:ofPlayer: have NOT been properly fixed in this update.

=== 1365setterFeedback-kfr.cs ===
Change Set:		setterFeedback-kfr
Date:			16 June 2007
Author:			Karl Ramberg

Fixes setter feedback in a viewer for slots of certain types -- color, graphic, player -- for which it had been faulty.

=== 1364viewerRepairs-sw.cs ===
Change Set:		viewerRepairs-sw
Date:			14 June 2007
Author:			Scott Wallace

Fixes up some errors from update 1361

=== 1363editorForTextual-yo.cs ===
Change Set:		editorForTextual-yo
Date:			14 June 2007
Author:			Yoshiki Ohshima

Reconstitute a script editor for texutally coded script when it is missing.

=== 1362guardNonZipArchive-kfr.cs ===
Change Set:		guardNonZipArchive-kfr
Date:			14 June 2007
Author:			Karl Ramberg

Treat old projects nicely.

=== 1361viewerConflicts-sw.cs ===
Change Set:		viewerConflicts-sw
Date:			12 June 2007
Author:			Scott Wallace

Addresses viewer issues caused whenever two or more different Morph classes declare conflicting specifications for a slot with the same getter.

The problematical slots were:

cursor:   TextMorph NCLabelMorph  PasteUpMorph FlashPlayerMorph GraphMorph

graphic:  SketchMorph VideoMorph  PasteUpMorph

This update solves the problem by providing separate getter methods [in Player] for the different interfaces.  This allows multiple interfaces for the same slot-name to co-exist in the method-interfaces dictionary of the vocabulary.



=== 1360textualCode-yo.cs ===
Change Set:		textualCode-yo
Date:			7 June 2007
Author:			Yoshiki Ohshima

Fixes a problem with textual code.

=== 1359nonColors-sw.cs ===
Change Set:		nonColors-sw
Date:			6 June 2007
Author:			Scott Wallace

Consider the 'color' of an InfiniteForm costume, and of Form-based costumes SketchMorph and ImageMorph, to be transparent.
Provide backstops in InfiniteForm for Form protocol calls issued when somebody's costume's color is an InfiniteForm.
Resist attempts to use color-setting protocols such as setHue:, setRed:, setAlpha, on such costumes

=== 1358duplicateFlx-sw.cs ===
Change Set:		duplicateFlx-sw
Date:			24 May 2007
Author:			Scott Wallace

Recompile scripts of all uniclasses involved in a duplication.

=== 1357dbusSugar-bf.cs ===
Change Set:		dbusSugar-bf
Date:			24 May 2007
Author:			Bert Freudenberg

Native Dbus support for Sugar launcher

=== 1356DBus-Core-bf-23.cs ===
Change Set:		DBus-Core-bf-23
Date:			24 May 2007
Author:			Bert Freudenberg

Import DBus-Core from http://source.impara.de/dbus

Name: DBus-Core-bf.23
Author: bf
Time: 15 May 2007, 7:14:02 pm
UUID: 1d45f974-0c82-421d-83dd-2b0cd62e7cb8


=== 1355MetaStringRule-yo.cs ===
Change Set:		MetaStringRule-yo
Date:			17 May 2007
Author:			Yoshiki Ohshima

Fixes a rule for string, and also add ? to mean one or zero element.

=== 1354servicesFix-sw.cs ===
Change Set:		servicesFix-sw
Date:			15 May 2007
Author:			Scott Wallace

Fix for a bug in FileList.

=== 1353FixExClipboard-tak.cs ===
Change Set:		FixExClipboard-tak
Date:			16 May 2007
Author:			Takashi Yamamiya

It detect whether if you have the plugin. And do the right thing.


=== 1352ExClipboardMorphic-tak.cs ===
Change Set:		ExClipboardMorphic-tak
Date:			15 May 2007
Author:			Takashi Yamamiya

Morphic support for ExtendedClipboard.
- Paste - Alt + v on PasteUpMorph or PluggableTextMorph.
- Drop a text or an image from e.g. abiword, gedit or firefox etc.

bug: modifier key should not be Alt (Alt is used by Sugar).


=== 1351ExUnixClipboard-tak.cs ===
Change Set:		ExtendedUnixClipboard-tak
Date:			15 May 2007
Author:			Takashi Yamamiya

ExtendedClipboard for X11.

=== 1350ExtendedClipboard.cs ===
Change Set:		ExtendedClipboard
Date:			16 May 2007
Author:			Sophie team

It is imported from Sophie07042601.zip.
'system calls' category in ExtendedClipboardWinInterface is removed because it included FFI code which can not be loaded into plugin image.


=== 1349bookControls-sw.cs ===
Change Set:		bookControls-sw
Date:			11 May 2007
Author:			Scott Wallace

Changes to the controls at the top of a BookMorph, and to the book-page sorter:

*  Show <page-number> / <total pages> in the control bar.
*  Move the more/fewer-controls button to the left of the bar.
*  Add a 'duplicate this page' command to the book menu.
*  Use larger tokens in the book-page sorter.
*  Eliminate the 'parts bin' checkbox in the book-page sorter.  This never worked and was always at best misleading.  Of course, it remains present in the project-sorter, where it works fine and is invaluable.
*  Eliminate the superfluous (, ), and # from the date/time readout at the top of TrashCan pages.

=== 1348virtualCursor2-bf-yo.cs ===
Change Set:		virtualCursor2-bf-yo
Date:			11 May 2007
Author:			Bert Freudenberg and Yoshiki Ohshima

Make it right on a platform without good cursor support.

=== 1347putNebraskaBack-yo.cs ===

=== 1346virtualCursorOnWin-yo.cs ===
Change Set:		virtualCursorOnWin-yo
Date:			11 May 2007
Author:			Yoshiki Ohshima

Disable scaled cursor on Windows for now.

=== 1345virtualCursor-bf.cs ===
Change Set:		virtualCursor-bf
Date:			2 May 2007
Author:			Bert Freudenberg

Scale the Cursor to match the virtual display's scale

=== 1344sugarNavHelp-sw.cs ===
Change Set:		sugarNavHelp-sw
Date:			10 May 2007
Author:			Scott Wallace

Tunes the wording of some items in the sugar-nav-bar, and provides balloon help for the virtual-display items.

=== 1343cleanerBadge-bf.cs ===
Change Set:		cleanerBadge-bf
Date:			10 May 2007
Author:			Bert Freudenberg

Remove one more button

=== 1342cleanBadge-bf.cs ===
Change Set:		cleanBadge-bf
Date:			10 May 2007
Author:			Bert Freudenberg

Remove unused fields in buddy badge

=== 1341biggerPolyHandles-kfr.cs ===
Change Set:		biggerPolyHandles-kfr
Date:			10 May 2007
Author:			Karl Ramberg

Makes the control points of polygons & curves larger and also makes the default sizes of polygon & curves pulled out from the Objects tool larger.

=== 1340fixColorInBar-yo.cs ===
Change Set:		fixColorInBar-yo
Date:			9 May 2007
Author:			Yoshiki Ohshima

Fix the default color of bar sane.

=== 1339pickerReverts-sw.cs ===
Change Set:		pickerReverts-sw
Date:			9 May 2007
Author:			Scott Wallace

Temporary workarounds for a family of bugs introduced by update 1316.  The attempt to make color-picking work properly during playback of event-recorder tapes cleaned some things up (specifically, removing reliance on direct calls to Sensor) but unfortunately broke some simple color-picking *not* initiated from the recolor halo-handle.  For now, to restore the health of such picking, we back out of some of the 1316 changes.  This makes color-picking again broken on event-replay, but for the moment this appears to be the lesser evil.

=== 1338flapTopMost-yo.cs ===
Change Set:		flapTopMostWhenOpened-yo
Date:			9 May 2007
Author:			Yoshiki Ohshima

Get the parts bin back to top in z-order.

=== 1337sugarListenerMar9-yo.cs ===
Change Set:		sugarListenerMar9-yo
Date:			9 May 2007
Author:			Yoshiki Ohshima

Really prevent the EtoyListenerMorph show up.

=== 1336fixBadge-bf.cs ===

=== 1335xoMenu-bf.cs ===
Change Set:		xoMenu-bf
Date:			9 May 2007
Author:			Bert Freudenberg

Make XO guys appear in menu and on badge

=== 1334OLPC-Display.cs ===
Change Set:		OLPC-Display
Date:			13 April 2007
Author:			Andreas Raab

A virtual OLPC display screen to allow for development for OLPC on regular machines. Enabled by turning on the preferences #enableVirtualOLPCDisplay.  Small modifications and adjustment was made by Yoshiki Ohshima.

=== 1333smootherXO-sw.cs ===
Change Set:		smootherXO-sw
Date:			9 May 2007
Author:			Scott Wallace

Ensure smoothing on the XO icons obtained.  And preinitialize the prototype, to avoid the reading-a-stream msg on first creation.

=== 1332xoChar-sw.cs ===
Change Set:		xoChar-sw
Date:			9 May 2007
Author:			Scott Wallace

Allows creation of a standard 'XO' icon in any size with any color pair.

Try:

(OLPCSupport xoCharacterWithHeight: 40  insideColor: Color yellow outsideColor: Color green) openInHand


=== 1331sugarNick-bf.cs ===
Change Set:		sugarNick-bf
Date:			8 May 2007
Author:			Bert Freudenberg

Set authorname to sugar's nick name

=== 1330sugarBuddies-bf.cs ===
Change Set:		sugarBuddies-bf
Date:			8 May 2007
Author:			Bert Freudenberg

track buddies in SugarLauncher

=== 1329BadgeExperiment-yo.cs ===

=== 1328fixupAfterBtnChange-yo.cs ===
Change Set:		fixupAfterButtonChange-yo
Date:			8 May 2007
Author:			Yoshiki Ohshima

The vanishing dismiss button problem reported by Bert is fixed by abstracting the logic to test the existence of dismiss button in the viewer.

=== 1327noMouseOverHalos-yo.cs ===
Change Set:		noMouseOverHalos-yo
Date:			7 May 2007
Author:			Yoshiki Oshima

Reverse the policy about mouse-over-halos in PasteUpMorphs -- now by default off.

=== 1326noSibs-sw.cs ===
Change Set:		noSibs-sw
Date:			7 May 2007
Author:			Scott Wallace

Don't offer the siblings submenu in the world halo menu.

=== 1325Trash2-tk.cs ===
Change Set:		Trash2-tk
Date:			7 May 2007
Author:			Ted Kaehler

Small correction to Player>>isInTrash.

=== 1324Clickable2-tk.cs ===
Change Set:		Clickable2-tk
Date:			7 May 2007
Author:			Ted Kaehler

Additions to momentary highlighting of all morphs that will do something when the user clicks on them.  Added ProjectViewMorphs, and fixed comments.  Hour glass while creating highlights, which can take a few seconds.  
To create a button that highlights when you press and hold, and unhighlights when you release:

ActiveHand attachMorph: World buildShowClickableButton.

-----
Or, execute these doIts.
to turn on for 3 seconds, then off:
World highlightActionButtons: nil.

to turn highlighting on:
World highlightActionButtons: true.

to turn highlighting off:  
World highlightActionButtons: false.



=== 1323MetaChangesMay5.cs ===

=== 1322BetterProdDetection-yo.cs ===
Change Set:		BetterProdDetection-yo
Date:			1 May 2007
Author:			Yoshiki Ohshima

A slightly better way to detect if the code is a production definition or not.

=== 1321SugarNav10-yo.cs ===
Change Set:		SugarNav9-yo
Date:			2 May 2007
Author:			Yoshiki Ohshima

Enable resizing, color changes.  Also changes the layering.

=== 1320saveSupplies-yo.cs ===
Change Set:		saveSupplies-yo
Date:			4 May 2007
Author:			Yoshiki Ohshima

A mean to retain the supplies contents.

=== 1319SISSMorphCopy-yo.cs ===
Change Set:		SISSMorphCopy-yo
Date:			4 May 2007
Author:			Yoshiki Ohshima

morph copy via SISS.

=== 1318MenuLiteral-yo.cs ===
Change Set:		MenuLiteral-yo
Date:			4 May 2007
Author:			Yoshiki Ohshima

Allow Menu type in S-expression form.

=== 1317Clickable-tk.cs ===
Change Set:		Clickable-tk
Date:			4 May 2007
Author:			Ted Kaehler

Provide momentary highlighting of all morphs that will do something when the user clicks on them.  The default is 3 seconds of highlighting.  In a project, execute:

World highlightActionButtons: nil.

For when we decide on a user interface for this, I have already included these useful calls: 
to turn highlighting on
World highlightActionButtons: true.

to turn highlighting off  
World highlightActionButtons: false.


=== 1316pickerAndProps-sw.cs ===
Change Set:		pickerAndProp-sw
Date:			4 May 2007
Author:			ScottWallace

Several interrelated fixes and cleanups to the ColorPickerMorph, the ObjectPropertiesMorph, and the TextPropertiesMorph, including:
* When the user clicks on the recolor icon in the halo, first bring up a small modal color picker (unless shift key down, of course.)
* In the small modal picker you can do four things:
   -- click on a color to choose it; the color clicked on will
        be applied to the object in question, and the color-picker
        will be dismissed.
  -- click on the 'black dot' to keep the color-picker up and make it modeless.
  -- click on the '+' to bring up the big property sheet.
  -- click on the 'x' at the top-left corner of the tool to dismiss the picker without choosing a new color.
* Make CANCEL in the Property-sheet actually cancel all changes made since the property-sheet was brought up.
* Bigger lettering in the property sheets, and better use of real-estate.
* Eliminate or grey-out items in the PS not relevant to current target.
* In the PS, eliminate the 'Button' button.
* Include the color and the shadow-offset in the set of things that get reverted when one cancels out of a property sheet.

For the special case of *text*...
* Show the changes immediately in the original text-morph.
* Eliminate the copy of the text that's inside the Text property sheet.
* Make the color chosen in color-picker apply only to the selection.
* CANCEL button restores original text and all original text properties.
* After a change based on the TPM, remove the selection highlighting in the original text so that its true color can be judged.  This certainly makes perfectly good sense when the edits apply to the entire text.  In cases where the user has selected a smaller range, the current strategy is to honor the last manually-selected range as the selection target for edits, but not to show its selection highlighting.  This is controversial, and perhaps in the next round we will resume showing the selection highlighting... stay tuned.

=== 1315Trash-tk.cs ===
Change Set:		Trash-tk
Date:			3 May 2007
Author:			Ted Kaehler

Bug:  allSiblingsDo was reporting objects in the Trash (ScrapsBook) and also ones that were dead but not freed by a garbage collect.
	After each emptyScrapsBook, do a garbageCollect, but only if the command came from EToys, not from Project saving.
	During allSiblingsDo, test if sibling is alive in the Trash, and don't use it.

=== 1314ClockMorphView-yo.cs ===
Change Set:		ClockMorphView-yo
Date:			3 May 2007
Author:			Yoshiki Ohshima

ClockMorph's nowTime didn't get set properly.

=== 1313SISSInstVarPutFix-yo.cs ===
Change Set:		SISSInstVarPutFix-yo
Date:			3 May 2007
Author:			Yoshiki Ohshima

instVarAt had a problem to set scripts and slotInfo of a uniclass object.

=== 1312argumentCountFix-yo.cs ===
Change Set:		argumentCountFix-yo
Date:			2 May 2007
Author:			Yoshiki Ohshima

There was a flaw to handle argument counts in Scriptor.

=== 1311sissFraction-yo.cs ===
Change Set:		sissFraction-yo
Date:			2 May 2007
Author:			Yoshiki Ohshima

Some care is needed for Fraction.  ScaledDecimal and Complex apprear to work without special casing as readFrom: works with them.

=== 1310SExpDefault1-yo.cs ===
Change Set:		SExpDefault1-yo
Date:			1 May 2007
Author:			Yoshiki Ohshima

For now, set the default to false.

=== 1309SExpCleanup-yo.cs ===
Change Set:		SExpCleanup-yo
Date:			1 May 2007
Author:			Yoshiki Ohshima

Remove a unused method.

=== 1308SExpProjWithSign-yo.cs ===
Change Set:		SExpProjWithSign-yo
Date:			1 May 2007
Author:			Yoshiki Ohshima

Make sure that the digital signing works.

=== 1307parseNode2-yo.cs ===
Change Set:		parseNode2-yo
Date:			13 April 2007
Author:			Yoshiki Ohshima

Fixes bugs in the parse node generation.

=== 1306PrecInTiles-yo.cs ===
Change Set:		PrecInTiles-yo
Date:			13 April 2007
Author:			Yoshiki Ohshima

This changes set changes the precedence rules in EToys tiles.  Instead of relying on the Morphic nested structure, this logic post-processes the generated parse tree by doing analysis based on operator procedence grammar way.

  The assumption is that in the 'expression' part of tiles, a longer expression is always created by the extension arrow, therefore it is always totally right associative tree.  Based on this, walking throught the tree is almost the same as parsing flat structure, therefore a simple operator precedence grammar works.

=== 1305ScriptorToParseNode1-yo.cs ===
Change Set:		ScriptorToParseNode1-yo
Date:			12 April 2007
Author:			Yoshiki Ohshima

Change Scriptor and all Tiles so that they can emit ParseNode.

=== 1304ScrptEncdrPool-yo.cs ===
Change Set:		ScrptEncdrPool-yo
Date:			12 April 2007
Author:			Yoshiki Ohshima

This changes the interface of ScriptEncoder.

=== 1303markSExpFormatV1-yo.cs ===
Change Set:		markSExpFormatV1-yo
Date:			6 April 2007
Author:			Yoshiki Ohshima

Make so that subsequent project published will be in S-Expression format version 1.0.

=== 1302parameterTypeFix-yo.cs ===
Change Set:		parameterTypeFix-yo
Date:			6 April 2007
Author:			Yoshiki Ohshima

Instead of trying to fetch the type of parameter from the dictionary in class, it does so from the sexp.

=== 1301projectLocal-yo.cs ===
Change Set:		projectLocal-yo
Date:			6 April 2007
Author:			Yoshiki Ohshima

Make the references project local. 

=== 1300SISSProject-yo.cs ===
Change Set:		SISSProject-yo
Date:			3 April 2007
Author:			Yoshiki Ohshima

Some modifications made to support the Project saving/loading.  To save a project in the new format, evaluate:

	Project publishInSexp: true



=== 1299StringEscape.cs ===
Change Set:		StringEscape
Date:			9 March 2007
Author:			Yoshiki Ohshima

Allows scripts with double-quotes, and also make the serialized results of other objects a bit more readable.

=== 1298SISS.cs ===
Change Set:		SISS
Date:			7 March 2007
Author:			Yoshiki Ohshima

An object serializer that uses s-expression as its format.

This variation of s-expression has a grammar:

ksexp ::= #'(' <name>:n <component>* #')'
component ::= (<ksexp> | <keyword> <string>)

and, two-nonterminals 'keyword' has a form: :keyword and name has a form: name.

  As you can see, this variation is a straight translation from XML.  the keyword-string pairs in an s-expression are unordered attributes, and the child s-expressions are ordered.

To use it, evaluate something like:

 obj1 := Array with: 1 with: true with: Object new.
 sexp1 := obj1 sissScanObjects.
 str1 := sexp1 prettyString.
 sexp2 := (MSExpParser parse: str1 with: #ksexp).
 obj2 := sexp2 sissReadObjects.

For a Morph, you can say:

  obj1 sissScanObjectsWithoutOwner.

which temporarily clear the owner of the morph, and restore it once the scanning is done.



=== 1297ScriptSerialization.cs ===
Change Set:		ScriptSerialization
Date:			7 March 2007
Author:			Yoshiki Ohshima

Let you externalize a script and bring it back.  To test it, you make a script with many different objects, open an inspector of the scriptor and evaluate:

	self createTestCopyAndCompare2.

You'll be asked to close the original, and then the method creates new one based on the serialized data from the original.  Then, the newly created script is externalized again and the result is compared with the output from the original.

   Internally, there is a dictionary passed around, and for the testing purpose, it is made up with the entries in the Refereneces pool.  This way is only good for testing.  In the real system, the dictionary should be filled with the objects in a particular project.


=== 1296SExp.cs ===
Change Set:		SExp
Date:			7 March 2007
Author:			Yoshiki Ohshima

A slightly small subset of S-expression.  See the definition to learn what it does.

=== 1295MetaCleanLeftOvers-yo.cs ===
Change Set:		MetaCleanLeftOvers-yo
Date:			1 May 2007
Author:			Yoshiki Ohshima

Remove a few unused methods.

=== 1294macroCharFix-yo.cs ===
Change Set:		macroCharFix-yo
Date:			14 April 2007
Author:			Yoshiki Ohshima

character literal in production should return itself, not the truth value.

=== 1293MetaWithForm2.cs ===
Change Set:		MetaWithForm2
Date:			1 March 2007
Author:			Yoshiki Ohshima

Define => in MMetaParser and compile it a couple of times.

=== 1292MetaWithForm.cs ===
Change Set:		MetaWithForm
Date:			1 March 2007
Author:			Alessandro Warth and Yoshiki Ohshima

=> is introduced. in the bootstrap compiler.

=== 1291MetaStage2and3.cs ===
Change Set:		MetaStage2and3
Date:			28 February 2007
Author:			Alessandro Warth and Yoshiki Ohshima

Compile the definition of MMeta by the code generated by the Bootstrap compiler and then do it by itself.

=== 1290MetaStage1.cs ===
Change Set:		MetaStage1
Date:			28 February 2007
Author:			Alessandro Warth and Yoshiki Ohshima

Compile the definition of MMeta classes by the Bootstrap compiler.

=== 1289MetaBootstrap.cs ===
Change Set:		MetaBootstrap
Date:			28 February 2007
Author:			Alessandro Warth and Yoshiki Ohshima

The bootstrap part of Meta-II parser in Squeak.

=== 1288thumbnailColor.cs ===
Change Set:		ProjectViewMorph-updateImageFrom
Date:			24 April 2007
Author:			Yoshiki Ohshima

Mitigate a problem.

=== 1287WarpBltCellSize-ar.cs ===
Change Set:		WarpBltCellSize-ar
Date:			27 April 2007
Author:			Andreas Raab

Fix a colormap problem with WarpBlt.

=== 1286SugarNav9-yo.cs ===
Change Set:		SugarNav9-yo
Date:			24 April 2007
Author:			Yoshiki Ohshima

Use bigger icon.

=== 1285reviveMultiTTC-yo.cs ===

=== 1284msgSetFixApr24-yo.cs ===
Change Set:		msgSetFixApr24-yo
Date:			24 April 2007
Author:			Yoshiki Ohshima

Looking for senders of at:put: (for example) ends up with an error.  The fix changes isUniClass to isSystemDefined not to be more sensible.

=== 1283bigPrefs-bf.cs ===
Change Set:		bigPrefs-bf
Date:			24 April 2007
Author:			Bert Freudenberg

Enable wider scrollbars and larger code font in non-dev image

=== 1282bigTempCursor-bf.cs ===
Change Set:		bigTempCursor-bf
Date:			24 April 2007
Author:			Bert Freudenberg

Use bigCursors as Morphic's temp cursors, too

=== 1281TextPlayerFont-tk.cs ===
Change Set:		TextPlayerFont-tk
Date:			23 April 2007
Author:			Ted Kaehler

In EToys, when a Player is on a TextMorph, there is a text category, and tiles for manipulating text.  Font and style information was not considered before.  This update establishes the rule that the destination text style is used.  Storing into text with the tiles: setCharacters:  setFirstCharacter: setCharacterAt: and setAllButFirst: use the font and size and emphasis of the text being stored into.  

In addition there was a bug in setAllButFirst: that would not store if the leading characters were the same.  This is fixed.

=== 1280SugarNav8-yo.cs ===
Change Set:		SugarNav8-yo
Date:			23 April 2007
Author:			Yoshiki Ohshima

The SugarButton now has a way to show the grayed out disabled state.

=== 1279alphaChannelFix-yo.cs ===
Change Set:		alphaChannelFix-yo
Date:			23 April 2007
Author:			Yoshiki Ohshima

- ProjectView with OLPC virtual display had a problem with alpha channel.
- grab patch without OLPC virtual display had a problem with alpha channel.

=== 1278FixCompressAgain-tak.cs ===
Change Set:		FixCompressAgain-tak
Date:			23 April 2007
Author:			Takashi Yamamiya

- A workaround to do SequentialSound>>compressWith:
- Only uncompressed sound is compressed in SoundEventMorph>>releaseCachedState.

You could not copy a SequentialSound including with OggSoundData
because they need the proper header. The second or more ogg sound should
process the first (header) sound before itself, but copying them cut their reference.
The easiest workaround would be making OggSoundData be immutable.


=== 1277ScriptHandleFix-tak.cs ===
Change Set:		ScriptHandleFix-tak
Date:			23 April 2007
Author:			Takashi Yamamiya

Add an icon for 'Press me' Button

=== 1276hideNav-yo.cs ===
Change Set:		hideNav-yo
Date:			22 April 2007
Author:			Yoshiki Ohshima

Guard a line with ifNotNil:.  I admit that I don't know if it is really the right thing, as hiding flap here should not have any significance.

=== 1275TNSize-sw.cs ===
Change Set:		TNSize-sw
Date:			22 April 2007
Author:			Scott Wallace

Decouple the size of thread-navigator thumbnails (in the TN, not the ones in the sorter) from the standard menu font.

=== 1274slipsAndSyms-sw.cs ===
Change Set:		slipsAndSmms-sw
Date:			21 April 2007
Author:			Scott Wallace

Two minor IDE tweaks:
1. Return a list of MethodReferences rather than the old-style Strings in the checkForSlips command..  This solves the bug that some methods could occur more than once in a message-list, if they were added to the list in both of the two different forms -- it actually happens

=== 1273SugarNav7-yo.cs ===
Change Set:		SugarNav7-yo
Date:			21 April 2007
Author:			Yoshiki Ohshima

- Change of some colors.
- disable traditional nav-bar when sugarNavigator preference is on.
- change the icon for supplies.
- fixes an issue related to languages.

=== 1272blueprintCat-sw.cs ===
Change Set:		blueprintCat-sw
Date:			21 April 2007
Author:			Scott Wallace

Add the blueprint-canvas-related tile commands to the 'as object' category.

Also, the ability to determine what category or categories a given Viewer entry belongs in -- useful if you've found an item using the Search pane of the Viewer -- was lost when it was decided last September to remove the menu icon from Viewer lines for commands.  This update offers a weak substitute, better than nothing:  the halo-menu of a 'viewer line' now offers this show-categories command.

=== 1271implicitSelf-sw.cs ===
Change Set:		implicitSelf-sw
Date:			21 April 2007
Author:			Scott Wallace

Implements an implicit-self option in tile scriptors and viewers.  Governed by #implicitSelfInTiles preference.
Control this preference either from the 'preferences' section of the World's Viewer or from a Preferences tool... or from a button you create by evaluating the following line:
	(Preferences buttonForPreference: #implicitSelfInTiles) openInHand.



=== 1270viewerCats-sw.cs ===
Change Set:		viewerCats-sw
Date:			20 April 2007
Author:			Scott Wallace

Cleanup of which categories are offered, in which order, in the Viewer on a world.  Also, in the popups for category choice within  category-viewer, always present scripts & variables first

Adds playfield-options and as-object categories to viewers of playfields/worlds when eToyFriendly is off..

=== 1269blueprintCanvas-sw.cs ===
Change Set:		blueprintCanvas-sw
Date:			18 April 2007
Author:			Scott Wallace

Item in world menu in non-eToyFriendly mode allows turning on and off of blueprint canvas.

=== 1268sorters-sw.cs ===
Change Set:		sorters-sw
Date:			19 April 2007
Author:			ScottWallace

Use larger icons, larger text, and a larger grid in the Project Sorter, which is used to sort the projects belong to a ThreadNavigator thread, and also in PageSorters used with BookMorphs, and the in the TabSorters used with the (now mostly disused) TabbedPalettes.

=== 1267SugarNav6-yo.cs ===
Change Set:		SugarNav6-yo
Date:			19 April 2007
Author:			SugarNav6-yo

Change the way supplies bin work.

=== 1266SugarNav5-yo.cs ===

=== 1265KedamaFIxApr18-yo.cs ===
Change Set:		KedamaFIxApr18-yo
Date:			18 April 2007
Author:			Yoshiki Ohshima

Backup code for a primitive was wrong.

=== 1264SugarNav4-yo.cs ===

=== 1263SugarNav3-yo.cs ===
Change Set:		SugarNav3-yo
Date:			17 April 2007
Author:			Yoshiki Ohshima

Fixes the issue with project saving.

=== 1262SugarNav2-yo.cs ===
Change Set:		SugarNav2-yo
Date:			17 April 2007
Author:			Yoshiki Ohshima

Some incremental changes to the bar.

=== 1261newScriptIcon-sw.cs ===
Change Set:		newScriptIcon-sw
Date:			13 April 2007
Author:			Scott Wallace

Make the text on the tile dragged from a viewer in response to choosing 'new script' from the viewe's menu show the right font

=== 1260bigCursorFix-bf.cs ===
Change Set:		bigCursorFix-bf
Date:			10 April 2007
Author:			Bert Freudenberg

Make replay show the new CursorWithAlpha correctly. Can also be used to test the new cursors on old VMs:
ActiveHand showTemporaryCursor: CursorWithAlpha olpcNormal


=== 1259SugarNav-yo.cs ===
Change Set:		SugarNav-yo
Date:			10 April 2007
Author:			Yoshiki Ohshima

An attempt to make an imitation of Sugar-like menu bar.

=== 1258playbackOnscreen-sw.cs ===
Change Set:		playbackOnscreen--sw
Date:			9 April 2007
Author:			Scott Wallace

Before opening a playiback theate, assure it's fully onscreen if possible.

=== 1257FasterMBWriting-mu.cs ===
Change Set:		FasterMultiByteStreamWriting-mu
Date:			17 January 2007
Author:			Masashi UMEZAWA

MultiByteFileStream>>nextPutAll: is slow because it writes each character to FileStream directly.
The new version uses on-memory stream before actual writing, which makes nextPutAll: much faster.



=== 1256BlobFIxes-yo.cs ===
Change Set:		BlobFIxes-yo
Date:			5 April 2007
Author:			Yoshiki Ohshima

Make BlobMorph a better citizen.

=== 1255DavStore-yo.cs ===
Change Set:		DavStore-yo
Date:			4 April 2007
Author:			Yoshiki Ohshima

  Make it possible to store projects onto a WebDAV folder.



=== 1254stringHaloHandle-sw.cs ===
Change Set:		stringHaloHandle-sw
Date:			2 April 2007
Author:			Scott Wallace

Fixes the bug that StringMorphs did not show the direction handle (except when being rotated), even if the showDirectionHandles preference was true.

=== 1253typoFix-sw.cs ===
Change Set:		typoFix-sw
Date:			1 April 2007
Author:			Scott Wallace

Fixes a typo in update 1247followPathSafety

=== 1252biggerCursors-bf.cs ===
Change Set:		biggerCursors-bf
Date:			21 March 2007
Author:			Bert Freudenberg

If you enable the biggerCursors preference and your VM supports ARGB cursors, all regular cursors will be enlarged by 2. Also, by default the OLPC cursor will be shown

=== 1251loadOLPCKeys-bf.cs ===
Change Set:		loadOLPCKeys-bf
Date:			30 March 2007
Author:			Bert Freudenberg

Load DSA private/public keypair from Sugar's owner.key file instead of generating our own

=== 1250noWorldSib-sw.cs ===
Change Set:		noWorldSib-sw
Date:			30 March 2007
Author:			ScottWallace

Disable the sibling items from the world's halo menu.  These never make sense for a world.

=== 1249paintingAspectRatio-sw.cs ===
Change Set:		paintingAspectRatio-sw
Date:			28 March 2007
Author:			Scott Wallace

Adds an item to the painting submenu of the halo menu of a SketchMorph allowing restoration of the original aspect ratio.

=== 1248removeVersNo-sw.cs ===
Change Set:		removeVersNo-sw
Date:			28 March 2007
Author:			Scott Wallace

Adds a service to the file list for removing a version number from a file-name -- often needed in preparation for pubishing an update, for example.

=== 1247followPathSafety-sw.cs ===
Change Set:		followPathSafety-sw
Date:			30 March 2007
Author:			ScottWallace

Guard against system lockup when a follow-path tile is used in a ticking script, and against system impairment during any execution of follow-path.

=== 1246cancelPainting-sw.cs ===
Change Set:		cancelPainting-sw
Date:			30 March 2007
Author:			ScottWallace

Several fixes and bulletproofings for issues relating to painting within an event-theatre recording, including:
* If a user initiates a cmd-drag within an event-theatre or playback space, terminate the playback.  The alternative is to allow playback to continue with spurious coordinates.

=== 1245scriptorHdr-sw.cs ===
Change Set:		scriptorHdr-sw
Date:			28 March 2007
Author:			Scott Wallace

Adds a little extra space between the player name and the script name in the header of a Scriptor.

=== 1244LargeHaloFeedBack-tak.cs ===
Change Set:		LargeHaloFeedBack-tak
Date:			28 March 2007
Author:			Takashi Yamamiya

Revert mouse feedback in the halo handles.

  ThreePhaseButtonMorph is used as a handle instead of Form or Ellipse to enable feedback.
I didn't choose ellipse because I wanted to use anti-alias for for halo icons to fit OLPC convention.
  ThreePhaseButtonMorph is slightly changed to make sure on:send:to: mechanism works well.

TODO:
- grow handle and scale handle looks same.


=== 1243plusButton-sw.cs ===
Change Set:		plusButton-sw
Date:			27 March 2007
Author:			ScottWallace

Makes the '+' button, which serves to add a new category-pane to the Viewer, activate on mouse-up, like other buttons in the etoy UI.

=== 1242ButtonFeedback-tak.cs ===
Change Set:		ButtonFeedback-tak
Date:			27 March 2007
Author:			Takashi Yamamiya

The feedback of button with image becomes better.

- Shadowed form for button press is automatically generated,
	and cached into FormDictionary mamed '*Pressed'.
- Use ThreePhaseButtonMorph instead of IconicButton for the viewer.


=== 1241MenuCopyFix2-tk.cs ===
Change Set:		MenuCopyFix2-tk
Date:			26 March 2007
Author:			Ted Kaehler

A fix for veryDeepCopy of a MenuItemMorph.  A MenuItemMorph points at its target morph with instance variable wordingProvider.  This Morph may be outside the tree of this copy, and should be shared (copied weakly).  As usual in cases like this, I defined veryDeepInner: and veryDeepFixupWith:
	Includes a checker method for finding offending classes.
	Includes fixes for using veryDeepCopy on a variety of classes.

=== 1240moreFontIndep-sw.cs ===
Change Set:		moreFontIndep-sw
Date:			23 March 2007
Author:			ScottWallace

A couple more tweaks further to the cause of making the appearance of the etoys experience independent of the settings of the IDE.  The changes here make the font used for various 'buttons' in the etoy UI, e.g. for script-status reporting, and for the 'search' button in a Viewer, not follow the broad system default button font but rather be designated by a custom interface.

=== 1239selectiveHalos-sw.cs ===
Change Set:		selectiveHalos-sw
Date:			26 March 2007
Author:			Scott Wallace

Make the selectiveHalos preference true in various theme and init code, for consistency with current take on olpc etoys ui.  For example, we need selectiveHalos to be true in order to suppress the recolor/property-sheet handle..

=== 1238launchUrl-bf.cs ===
Change Set:		launchUrl-bf
Date:			23 March 2007
Author:			Bert Freudenberg

Load project from URL in STARTUP message. This allows launching projects from the web activity

=== 1237clockFixes-sw.cs ===
Change Set:		clockFixes-sw
Date:			15 March 2007
Author:			ScottWallace

The show-24-hr feature of the ClockMorph got broken by world-stethoscope code; this update fixes that.  REF: TRAC ticket #1044 (new defect).

Also:  improves the halo-menu for the ClockMorph:
- uses checkboxes for the 24-hr and show-seconds toggles, so that  their wordings in a persistent menu remain correct.
- removes the spurious 'change string' item from the menu.
- in servicing 'change font', uses the font-picker that allows selection of both font and emphasis.  This avoids the second bug in TRAC ticket #1044 regarding emphasis change before any font change.

=== 1236bookMenuFixes-sw.cs ===
Change Set:		bookMenuFixes-sw
Date:			15 March 2007
Author:			Scott Wallace

Reconnects two book-menu items relating to visual effects and sounds to the code they are meant to invoke.

[Trac #1066] Can not set sound and visual effect for Book.


=== 1235evtThFixes-sw.cs ===
Change Set:		evtThFixes-sw
Date:			13 March 2007
Author:			Scott Wallace

1.  Works around a failure found when an event-playback that was invoked by an EventPlaybackButton (now obsolete) created earlier is terminated.
2.  Shortens the main EventTheatre menu by moving the more obscure items into a 'more...' submenu.


=== 1234playbackInvoker-sw.cs ===
Change Set:		playbackInvoker-sw
Date:			9 March 2007
Author:			Scott Wallace

Consolidates the various playback-invokers into a single class.
Offers textual playback-invoker variant.
Allows playback-invoker, via its menu, to specify where the playback window should appear -- three choices: (a) at the origin of the button's container (b) at the button's position and (c) at the cener of the screen.
Adds playback-invoker menu commands to adopt scaled-down images of the initial picture, the final picture, and the caption, as the graphic of the playback-invoker.
The imprinting of 'HINT' is now governed by a separate menu item in the invoker's halo mehu; and it now adjusts appropriately to the size and aspect ratio of the button when blasting the HINT bits on top of the existing icon.

Note that the playback buttons are SketchMorphs, and as such you can repaint them, thus achieving any appearance you desire.

Adds a preference that governs whether an Event Theater should vanish as soon as you publish it (the behavior that Alan favors.)
Repackages the feature requested by Alan whereby a playback button can change its appearance to be a 50% scaled-down version of the final appearance of the playback window after playback.  This is called the 'post-playback feature'.  governed by an item in the playback-invoker's halo menu.

=== 1233VideoForSq-fixes2-dgd.cs ===
Change Set:		VideoForSqueak-fixes2-dgd
Date:			12 March 2007
Author:			Diego Gomez Deck <DiegoGomezDeck@consultar.com>
- Removed UnscriptedVideoPlayer and VideoPlayer classes; moving back all the methods to Player; to avoid problems with senders of #isSystemDefined (as Yoshiki pointed me).
- Renamed Player>>setBrightness: and Player>>getBrightness (to setVideoBrightness: and getVideoBrightness) to avoid the conflict with the methods in the OLPC Image.


=== 1232VideoForSq-fixes-dgd.cs ===

=== 1231Morphic-OggCodec-tak.cs ===
Change Set:		Morphic-OggCodec
Date:			10 March 2007
Author:			Takashi Yamamiya

SoundRecorder and etoys (.pr file) support for
Ogg vorbis / speex codec module.


=== 1230OggCodec-tak.cs ===
Change Set:		OggCodec
Date:			10 March 2007
Author:			Takashi Yamamiya

Ogg vorbis / speex codec module.
Try:
OggDriver example.


=== 1229categoryNameFont-sw.cs ===
Change Set:		categoryNameFont-sw
Date:			5 March 2007
Author:			Scott Wallace

Makes the font used in the category header of a Viewer not be dependent on the IDE's settings for button font and menu font.

=== 1228putUpdate-sw.cs ===
Change Set:		putUpdate-sw
Date:			2 March 2007
Author:			Scott Wallace

Strip out the special-casing for olpc in the UI acompanying update publishing.

=== 1227BookMark-save-tk.cs ===
Change Set:		BookMark-save-tk
Date:			1 March 2007
Author:			Ted Kaehler

BookMarks are made from SimpleButtonMorphs that point to a book.  Long ago, they were used as links from one SqueakPage to another.  When SqueakPages are stored in separate files, BookMarks are converted to URLMorphs.  
	When a project was being written out, a BookMark that passed the test of pointing to a BookMorph, and got converted to a URLMorph.  Recently this did not work, and the BookMark was removed from the Morph structure in the stored file and disappeared. 
	Since we don't use SqueakPages, I removed the code the converts BookMarks.  Projectw with BookMarks can now be stored.

=== 1226helpFlapLayer-sw.cs ===
Change Set:		helpFlapLayer-sw
Date:			1 March 2007
Author:			Scott Wallace

A fix to a layer-management issue in the recently-added help-in-flap flaps.

=== 1225phraseSubmorphs-yo.cs ===
Change Set:		phraseSubmorphs-yo
Date:			27 February 2007
Author:			Yoshiki Ohshima

PhraseTileMorph may have one submorph when a 'button down/up?' tile is used.

=== 1224noHandFix-sw.cs ===
Change Set:		noHandFix-sw
Date:			21 February 2007
Author:			Scott Wallace

Circumvents a bug encountered when painting is initiated with a nil event.

=== 1223hintFix-sw.cs ===
Change Set:		hintFix-sw
Date:			21 February 2007
Author:			Scott Wallace

The logic for when to show the HINT emblazoned on the initial picture nd when to show the final-state at larger size on the PlaybackInvoker had gotten inadvertently broken in update 1210; fixed here.

=== 1222noFlapForPlayback-sw.cs ===
Change Set:		noFlapForPlayback-sw
Date:			21 February 2007
Author:			Scott Wallace

The help-flap for the event-theatre was being put up when a playback space was opened, which was inappropriate; herein fixed.

=== 1221mapUniclass.cs ===

=== 1220initializeRandom-yo.cs ===
Change Set:		initializeRandom-yo
Date:			20 February 2007
Author:			Yoshiki Ohshima

At the start up time, RandomForPicking is initialized.

=== 1219helpInFlap-sw.cs ===
Change Set:		helpInFlap-sw
Date:			20 February 2007
Author:			Scott Wallace

Puts help-windows into flaps stacked up on the left edge of the screen.


=== 1218paintBoxPlayback-sw.cs ===
Change Set:		paintBoxPlayback-sw
Date:			20 February 2007
Author:			Scott Wallace

When playing back an event-theatre-recorded tape, assure the PaintBoxMorph defaults in place at the time of the recording are again in effect..

=== 1217locNotInBasic-sw.cs ===
Change Set:		locNotInBasic-sw
Date:			18 February 2007
Author:			Scott Wallace

Remove location from basic category, as per Yoshiki's recommendation.

=== 1216test-yo.cs ===
Change Set:		test-yo.cs
Date:			17 November 2006
Author:			Yoshiki Ohshima

just a test

=== 1215newStream-yo.cs ===
Change Set:		newStream-yo
Date:			18 February 2007
Author:			Yoshiki Ohshima

Switches the update stream to a new location on tinlizzie.org.

=== 1214DAVUpdates-yo.cs ===
Change Set:		DAVUpdates-yo
Date:			17 November 2006
Author:			Yoshiki Ohshima and Takashi Yamamiya

It enables to upload update changesets to WebDAV folder.


=== 1213XML-Parser.cs ===
Change Set:		XML-Parser
Date:			3 February 2007
Author:			Michael Rueger

XML parser from XML-Parser-mir.9.mcz at: http://www.squeaksource.com/XMLSupport/.  To keep changes at one location, it is filed out as a change set.

=== 1212pointType-sw.cs ===
Change Set:		pointType-sw
Date:			15 February 2007
Author:			Scott Wallace

The beginnings of an etoy Point type.  Selectable as a value-type for any user-defined variable, and also used for a new standard, point-valued slot named 'location'

=== 1211abandonDialog-sw.cs ===
Change Set:		abandonDialog-sw
Date:			14 February 2007
Author:			Scott Wallace

Fixes a typo in the dialog undertaken when an unsaved EventTheatre is abandoned by the user, and makes the language a bit less flippant...>

=== 1210editFromPlayback-sw.cs ===
Change Set:		editFromPlayback-sw
Date:			14 February 2007
Author:			Scott Wallace

Allows a direct way to get from playback-theatre to a score-viewing event-theatre.
Fix woring in an informer in xxx



=== 1209printDecFix-sw.cs ===
Change Set:		printDecFix-sw
Date:			15 February 2007
Author:			Scott Wallace

A fix for Number >> printShowingDecimalPlaces:, affecting the display of decimal parts that require leading zeroes.  An example of the kind of case that was broken was:
	0.001 printShowingDecimalPlaces: 3
which should yield '0.001' but instead was answering '0.100'


=== 1208rotatedScriptor-sw.cs ===
Change Set:		rotatedScriptor-sw
Date:			14 February 2007
Author:			Scott Wallace

Fixes the bug reported by Karl Ramberg:   dismissing a rotated Scriptor had left an unwanted TransformationMorph on the screen.  Alsom, the conventional animation back to the Viewer of the dismissed Scriptor did not work properly in the case of a rotated Scriptor -- fixes that too. 

=== 1207TextMorphCategory-yo.cs ===
Change Set:		TextMorphCategory-yo
Date:			13 February 2007
Author:			Yoshiki Ohshima

Get rid of one of inconsistent 'color' properties for text.

=== 1206silenceLauncher-yo.cs ===

=== 1205thumbInHelpWindow-sw.cs ===
Change Set:		thumbInHelpWindow-sw
Date:			13 February 2007
Author:			Scott Wallace

Fixes the size of the thumb in the olpc scrolling help panes.

=== 1204fontAvailable-yo.cs ===
Change Set:		fontAvailable-yo
Date:			12 February 2007
Author:			Yoshiki Ohshima

Fix one of many  imcompatibility between FontSet and font.

=== 1203timelineLabels-sw.cs ===
Change Set:		timelineLabels-sw
Date:			11 February 2007
Author:			Scott Wallace

Improve the appearance of the time-line readouts in an event roll:  use a larger font, and don't have the corresponding actual impinge on the number.

=== 1202evtTheatreFixes-sw.cs ===
Change Set:		evtTheatreFixes-sw
Date:			11 February 2007
Author:			Scott Wallace

Remove originating event theatre upon publishing to a button.
Place just-published playback buttons at top-left of screen rather than opening in the hand.
Move magnification-slider of event-roll to the right of the labels.
Make help-displayer resize appropriately from the yellow handle of its halo.


=== 1201moreEvtTheatreFixes-sw.cs ===
Change Set:		moreEvtTheatreFixes-sw
Date:			5 February 2007
Author:			Scott Wallace

More fixes and improvesments for the event-theatre.

*  You now successfully nest event-theatre playbacks by dropping an eventPlaybackButton into an EventRoll.
*  Adds a utility that *accurately* computes the total duration of an event-recording-tape.  The long-standing heuristic was always broken.
*  When cleaning up evt-recorder artifacts surrounding a given event-theatre, we now no longer clobber hands belonging to other event-theatres.
*  Adds a variant to #openInWorld which will open an object in a Worldlet [content area of an Event Theatre] rather than at large in the full World if appropriate.
*  Fixes a bug in EventRecordingSpace>>mouseDownPriority introduced in update 1159eventRoll.
*  Fixes bugs relating to the saved 'before' and 'after' pictures of event-theatres reopened from the two kinds of theatre-launching buttons.  These had formerly not been preserved across saving-to-a-button, then reopening editing from that button.



=== 1200numberOfPages-sw.cs ===
Change Set:		numberOfPages-sw
Date:			31 January 2007
Author:			Scott Wallace

Adds to book category of Viewer a slot reporting number of pages in the book.

=== 1199evtTheatreFixes-sw.cs ===
Change Set:		evtTheatreFixes-sw
Date:			2 February 2007
Author:			Scott Wallace

Retract the balloon help for the stop-recording-voiceover button, which was distracting and could interfere with the visibility of the theatre while doing playback.
Tolerate nil balloon-help argument in EvetnRecordingSpace>>buttonWithLabelactionSelectorballoonText:

=== 1198numericReadouts-sw.cs ===
Change Set:		numericReadouts-sw
Date:			15 January 2007
Author:			Scott Wallace

A number of improvements to input-handling and to output-formatting of etoy numeric readouts, as seen in, e.g., viewers and watchers.

Allows numeric readouts to show e-notated values more felicitously.

When e-notation is required, the 'decimal places' setting is used to determine how many decimal places to show in the can=onical e-representation.

Ignore blanks when processing user input to a numeric readout.

Support a wider range of number-of-decimal-places choices [up to 10 places directy; larger number supported also, though there's not at present a UI for specifying > 10 decimal places.

Do not put up debuggers when user type-in to numeric-valued field is a bad number.
Allow numeric type-in to begin with a decimal point, or with a minus-sign followed by a decimal point.

Borrows some code in Frank Sergeant's 'fcsPrintShowingDecimals' change-set from Mantis and from David' Lewis's fixes in Squeak3.9 for #floatPrecisionForDecimalPlaces:.

There are still some strange effects still not completely understood, but this update should serve to improve matters greatly both on input-processing and on representing awkward values in such readouts.

=== 1197protocolConflicts-sw.cs ===
Change Set:		protocolConflicts-sw
Date:			16 January 2007
Author:			Scott Wallace

Adds a method that tracks down slot-protocol conflicts in etoy vocabularies.  

Running it, we discover, in addition to the #graphic conflict worked-around in update 1191assignToGraphic, conflicts in #cursor and #color.

=== 1196eventRollFixes-sw.cs ===
Change Set:		eventRollFixes-sw
Date:			17 January 2007
Author:			Scott Wallace

Replaces the cmd in the event-roll's menu that let you revert to the incoming tape; in its place,offer the same, more general, 'revert to version...' command now implemented for the Event Theatre.

Reject a drop of a mouse-event-sequence-morph which would create a time overlap/conflict with existing mouse sequences in the event roll.  CAUTION -- best results still will be obtained by *not* lifting mouse-sequence morphs out of the event roll except to reposition them between the same two surrounding mouse-sequence morphs.  You're playing with fire here.

=== 1195evtTheatreVersions-sw.cs ===
Change Set:		eventTheatreFixes-sw
Date:			17 January 2007
Author:			Scott Wallace

Provides a Versions feature for the Event Theatre; can be invoked from the menu of both the Event Theatre and its affiliated Event Roll.

=== 1194smallHandlesAvail-sw.cs ===
Change Set:		smallHandlesAvail-sw
Date:			17 January 2007
Author:			Scott Wallace

When the biggerHandles preference is not set to true, restore the traditional halo-handle-icons; this is just for the convenience of users not operating on the olpc hardware.
Note:  since a recent update clobbered the small-halo-icon entries in the form dictionary, this update makes separate entries for the large and small halo icons, and installs the appropriate one into the dictionary under, for example, Halo-Grow, from whence the halo code will retrieve it.

Caution: This change-set contains an essential Postscript.

=== 1193lessEagerInTheatre-sw.cs ===
Change Set:		lessEagerInTheatre-sw
Date:			13 January 2007
Author:			Scott Wallace

Extends Yoshiki's less-eager-interpolation work of update 1187 to work in the variant of the EventRecorder used in conjunction with the Event Theatre.

=== 1192initialSetupForB2-yo.cs ===

=== 1191assignToGraphic-yo.cs ===
Change Set:		assignToGraphic-yo
Date:			16 January 2007
Author:			Yoshiki Ohshima

The side-effect of having read-only graphic slot at VideoMorph is that graphic slot of all sketch morphs becomes read-only.  This is a bug, but for now we just make VideoMorph's graphic read-write.

=== 1190sliderExtent-yo.cs ===

=== 1189forgivingTallyStop-yo.cs ===

=== 1188BookTileAndTrash-yo.cs ===
Change Set:		BookTileAndTrash-yo
Date:			15 January 2007
Author:			Yoshiki Ohshima

A flag to allow or not allow dragging via the book title.

=== 1187lessEagarInterpolation.cs ===
Change Set:		lessEagarInterpolation
Date:			12 January 2007
Author:			Yoshiki Ohshima

Improve EventRecorderMorph's playback interpolation logic so that it doesn't create excess interpolated events.

=== 1186haloFromDeadHand-yo.cs ===

=== 1185noAutoRun-bf.cs ===
Change Set:		noAutoRun-bf
Date:			12 January 2007
Author:			Bert Freudenberg

Do not automatically run Welcome project

=== 1184cleanupPlayer2-yo.cs ===
Change Set:		cleanupUninstanciatedPlayer2-yo
Date:			11 January 2007
Author:			Yoshiki Ohshima

#(Player CardPlayer Component MouseSensorMorph MouseDownMorph MouseOverMorph KedamaExamplerPlayer KedamaSequenceExecutionStub KedamaTurtleVectorPlayer2 UnscriptedPlayer UnscriptedCardPlayer) collect: [:s | (Smalltalk at: s) isSystemDefined].

(Player allSubclasses reject: [:s | #(Player CardPlayer Component MouseSensorMorph MouseDownMorph MouseOverMorph KedamaExamplerPlayer KedamaSequenceExecutionStub KedamaTurtleVectorPlayer2 UnscriptedPlayer
UnscriptedCardPlayer) includes: s name]) select: [:e | e isSystemDefined]

=== 1183launcher2-yo.cs ===
Change Set:		launcher2-yo
Date:			11 January 2007
Author:			Yoshiki Ohshima

One more fix to the launcher.

=== 1182launcher-yo.cs ===
Change Set:		launcher-yo
Date:			11 January 2007
Author:			Yoshiki Ohshima

Change the initial buttons.

=== 1181LargeButtonMisc1-tak.cs ===
Change Set:		LargeButtonMisc1-tak
Date:			11 January 2007
Author:			Takashi Yamamiya

Fix my misusing about fonts.

=== 1180LargeButtonMisc-tak.cs ===
Change Set:		LargeButtonMisc-tak
Date:			11 January 2007
Author:			Takashi Yamamiya

- ? button in AllScripts, AllPlayers and ObjectCatalog
- Menu button in Book
- Text box of search pain
- Menu button in EventTheatre
- Viewer button in AllPlayers
- RightCaret and DownCaret of EventTheatre, Book, AllScripts.



=== 1179LargeHalo-tak.cs ===
Change Set:		LargeHalo-tak
Date:			10 January 2007
Author:			Takashi Yamamiya

Set handles size to 30 px, and replace their icon bitmap.

=== 1178changePaintBoxFont-yo.cs ===
Change Set:		changePaintBoxFont-yo
Date:			9 January 2007
Author:			Yoshiki Ohshima

Use BitstreamVeraSans 9 for buttons in the paintbox.

=== 1177UserScriptLineFix-yo.cs ===
Change Set:		UserScriptLineFix-yo
Date:			9 January 2007
Author:			Yoshiki Ohshima

Fixes viewer line layout for user scripts.

=== 1176FontUpdate-yo.cs ===
Change Set:		FontUpdate-yo
Date:			9 January 2007
Author:			Yoshiki Ohshima

The fixing font feature is revisited.  One of the theory back then was that calling fixLayout is expensive.  However, it is after all several calls of layoutChanged so that it can't be that expensive.  (One time, it looked very slow, but it was when fixLayout is called for each tile it contains.)   Another theory is that font change is needed only when a font used in a project is missing in the image.  So, this couldn't deal with the case where only the eToys font is changed from an existing one to another.  Finally, there was an issue when a scriptor is not visible in the world.

This change set addresses these cases.  There is still a pretty bad hack (if you look at the usage of #== in some methods, and figure out why it is ==, you got it)...

=== 1175ButtonLarger-tak.cs ===
Change Set:		ButtonLarger-tak
Date:			8 January 2007
Author:			Takashi Yamamiya

Buttons and handles size become 30 pixels.


=== 1174LargerFontAgain-tak.cs ===
Change Set:		LargerFontAgain-tak
Date:			8 January 2007
Author:			Takashi Yamamiya

Make fonts of buttons, flaps, menus larger.

=== 1173UndoFont-kfr.cs ===

=== 1172ScrptToolFont-yo.cs ===
Change Set:		ScrptToolFont-yo
Date:			5 January 2007
Author:			Yoshiki Ohshima

Make AllScriptTool honor the size of buttonFont.

=== 1171AllPlayerSize-yo.cs ===
Change Set:		AllPlayerSize-yo
Date:			5 January 2007
Author:			Yoshiki Ohshima

Make AllPlayersTool honor the size of buttonFont.

=== 1170MPEGPlayerBtnSize-yo.cs ===
Change Set:		MPEGPlayerBtnSize-yo
Date:			5 January 2007
Author:			Yoshiki Ohshima

Make MPEGPlayer honor the size of buttonFont.

=== 1169EventRecorderBtnSize-yo.cs ===
Change Set:		EventRecorderBtnSize-yo
Date:			5 January 2007
Author:			Yoshiki Ohshima

Make RecordingControl honor the size of buttonFont.

=== 1168EToysFontAndCaret-tak.cs ===
Change Set:		EToysFontAndCaret-tak
Date:			5 January 2007
Author:			Takashi Yamamiya

- Use KomikaText 21 as etoys font.
- Use KomikaTextKaps 24 as balloon font.
- Use  KomikaText 18 as other fonts.
- Carets have two pixel width.


=== 1167RecorderButtonSize-yo.cs ===
Change Set:		RecorderButtonSize-yo
Date:			4 January 2007
Author:			Yoshiki Ohshima

Make RecordingControl honor the size of buttonFont.

=== 1166chgLangSearchPane-yo.cs ===
Change Set:		chgLangSearchPane-yo
Date:			3 January 2007
Author:			Yoshiki Ohshima

Adjust the logic so that the right morph in the search pane is found when changing the language.

=== 1165WatcherVarNameFix.cs ===
Change Set:		WatcherVarNameFix
Date:			20 December 2005
Author:			Korakurider

Variable name in watcher is properly translated on startup, 
but accidentally goes back to untranslated.
An example case to reproduce this is:
  + set language other than english
  + tear off watcher for numeric value of slider
  + rename slider
This patch fixes the case described above

=== 1164WsRefactoring-ka.cs ===
Change Set:		WsRefactoring-ka
Date:			31 December 2006
Author:			Kazuhiro Abe

Refactoring of World-Stethoscope.
- Remove code duplication.
- Add high/low pass filter.

=== 1163AtIfAbsentPut-md.cs ===
Change Set:		AtIfAbsentPut
Date:			22 December 2006
Author:			Marcus Denker

Refactoring from at: ifAbsent:[at:put:] to at:ifAbsentPut: for some methods

=== 1162FasterIfAbsentPut-md.cs ===
Change Set:		FasterIfAbsentPut-md
Date:			21 December 2006
Author:			Marcus Denker

Dictionary>>#at:ifAbsentPut: searches two times the dictionary when the key is absent:

self at: key ifAbsent: [self at: key put: aBlock value]

This changeset provides a version that calls #findElementOrNil: only once and
a slightly faster implementation of Association>key:value. This should make
Dictionary>>at:put a little bit faster, too.

The changeset provides a simple test for #at:ifAbsentPut.


=== 1161loadKomika-yo.cs ===
Change Set:		loadKomika-yo
Date:			3 January 2007
Author:			Yoshiki Ohshima

Load Komika fonts from http://pedroreina.net/apostrophiclab/0141-KomikaText/komtext_tt.zip.

=== 1160rebuildIcons-sw.cs ===
Change Set:		rebuildIcons-sw
Date:			20 December 2006
Author:			Scott Wallace

Rebuild all the icons used in the Objects catalog and Suppies bin.

=== 1159eventRoll-sw.cs ===
Change Set:		eventRoll-sw
Date:			25 December 2006
Author:			Scott Wallace

Adds a piano-roll-like script-editor for event-recordings.  Hit the Script icon in any EventTheatre that already has a recording to get its EventRoll.  Hit the magenta '?' button in the EventRoll to get instructions for using the EventRoll.

This is a first alpha of a substantial body of code, so you may expect a number of bugs and issues to arise for the next little while.

=== 1158haloNotif-sw.cs ===
Change Set:		haloNotif-sw
Date:			24 December 2006
Author:			Scott Wallace

Notifies a morph both before and after it has been rotated, resized, or rescaled via the halo.

=== 1157putUpdatePrompt-sw.cs ===
Change Set:		putUpdatePrompt-sw
Date:			8 December 2006
Author:			Scott Wallace

The last prompt before an update is actually published to an update stream will now include a statement of what the  current system version code is.  This may help prevent  inadvertently publishing to wrong update stream, and in any case should make for greater confidence when confronted with the prompt.

=== 1156mergeRotCenter-yo.cs ===
Change Set:		mergeRotCenter-yo
Date:			21 December 2006
Author:			Yoshiki Ohshima

fix some typo and change balloon help text.

=== 1155RotationEnh.cs ===

=== 1154makeSoundRevert-yo.cs ===
Change Set:		makeSoundRevert-yo
Date:			21 December 2006
Author:			Yoshiki Ohshima

Put make sound back.

=== 1153categoryReordering-yo.cs ===
Change Set:		categoryReordering-yo
Date:			20 December 2006
Author:			Yoshiki Ohshima

Reorder Viewer categories.

=== 1152TRPiano-yo.cs ===
Change Set:		TRPiano-yo
Date:			20 December 2006
Author:			Yoshiki Ohshima

English translation for PianoKeyboardMorph.

=== 1151PianoFixesDec20-yo.cs ===
Change Set:		PianoFixesDec20-yo
Date:			20 December 2006
Author:			Yoshiki Ohshima

Rename sticky variable to allowingChord.
Stop all sound when deleting.
Add Etoys interface to allowingChord.

=== 1150MrgWsClock-ka.cs ===
Change Set:		MrgWsClock-ka
Date:			20 December 2006
Author:			Kazuhiro Abe

Merge WsClockMorph and ClockMorh.

=== 1149MrgWsPiano-ka.cs ===
Change Set:		MrgWsPiano-ka
Date:			20 December 2006
Author:			Kazuhiro Abe

Merge WsPianoKeyboardMorph and PianoKeyboardMorph.

=== 1148WsRecategorize-yo.cs ===
Change Set:		WsRecategorize-yo
Date:			20 December 2006
Author:			Yoshiki Ohshima

Remove a few items from supplies bin.

=== 1147batchPenPrefValue-yo.cs ===
Change Set:		batchPenPrefValue-yo
Date:			20 December 2006
Author:			Yoshiki Ohshima

Change the default value of batch pen trails.

=== 1146timesRepeat-sw.cs ===
Change Set:		timesRepeat-sw
Date:			20 December 2006
Author:			Scott Wallace

Adds a 'Repeat' tile to etoys.

Caution:  All the indicated repetitions of the code in the Do section are run atomically when the Repeat complex is run.   It is tantalizing to contemplate an implementation in which the repetitions are distributed across successive ticks of a ticking script, but that is not what we have here.

NB There are still some glitches to be ironed out -- see below -- but the feature is usable.

Obtain a Repeat...Times tile from either of two places:
  -- a Scriptor's menu
  -- the 'miscellaneous' category in a Viewer

Still faulty:
  --  Drop-zone-highlight [green] feedback often not properly offered in the TIMES areas.
  --  Extension arrow is presented but nothing actually happens when you click on it yet.

=== 1145TrashCanCommands-yo.cs ===
Change Set:		TrashCanCommands-yo
Date:			18 December 2006
Author:			Yoshiki Ohshima

A kludge way to add a slot and a command to the global scraps book.

=== 1144polygonFixup-yo.cs ===
Change Set:		polygonFixup-yo
Date:			18 December 2006
Author:			Yoshiki Ohshima

tailor the polygon enhancement to the OLPC image.

=== 1143PolygonEnh-tetha.cs ===

=== 1142undoResizeFixes-sw.cs ===
Change Set:		undoResizeFix-sw
Date:			15 December 2006
Author:			Scott Wallace

Fixes a subtle and damaging bug reported by Abe-San concerning the undo of resizing.
Adds fixup of damage incurred because of this bug to the repairs undertaken when 'attempt misc repairs' (authoring tools menu) is requested.
Does a one-time fixup of such errors at the time this update is loaded.

Also fixes two *other* bugs relating to the undo of resizing reported by Jerome Peace, see:
http://bugs.impara.de/view.php?id=5499.

=== 1141testTileWidth-sw.cs ===
Change Set:		testTileWidth-sw
Date:			7 December 2006
Author:			Scott Wallace

More fixes concerning the hResizing property of CompoundTileMorphs.

=== 1140offsetForPhrase-sw.cs ===
Change Set:		offsetForPhrase-sw
Date:			7 December 2006
Author:			Scott Wallace

Extends the standard hand offset introduced in update 0929GrabOffset-ar to the case of tearing off an assignment phrase from a Viewer.  Note that these offsets only occur on phrases just grabbed from Viewers.  There's still a case to be made for applying them more generally, but this update is not quite that adventurous.

=== 1139BooklikeMorph-kfr.cs ===

=== 1138rigitPhrase-yo.cs ===
Change Set:		rigitPhrase-yo
Date:			6 December 2006
Author:			Yoshiki Ohshima

prevent a phrase tile in a holder becomes in strange size.

=== 1137FITB-Layout-tak.cs ===
Change Set:		FITB-Layout-tak
Date:			6 December 2006
Author:			Takashi Yamamiya

Fix a layout problem when a FillInTheBlank has long query or initial answer.

=== 1136SMFix3.cs ===

=== 1135selectionDeleteFix-sw.cs ===
Change Set:		selectionMorphFix-sw
Date:			4 December 2006
Author:			Scott Wallace

Fixes a bug in deleting a multiple selection which slipped by in update 1087deleteAllHalos.

=== 1134stopSound-sw.cs ===
Change Set:		stopSound-sw
Date:			30 November 2006
Author:			Scott Wallace

When 'stopRunningAll' is invoked, e.g. by hitting the STOP button or by initiating painting, the Sound Player is no longer shut down.  Instead, individual players' sounds are terminated individually.

Also, strips out an old #allScriptors hook and related detritus.

=== 1133soundRecorderFix-sw.cs ===
Change Set:		soundRecorderFix-sw
Date:			30 November 2006
Author:			Scott Wallace

As per a recommendation by Dominique Dutoit on squeak-dev mailing list, 26-Nov-06, backs out of a change in SoundRecorder that broke sound-recording on a mac.

=== 1132eventTheatreSupport-sw.cs ===
Change Set:		eventTheatreSupport-sw
Date:			29 November 2006
Author:			Scott Wallace

Varioius changes in outside classes in support of the Event Theatre.

=== 1131eventTheatre-sw.cs ===
Change Set:		eventTheatre-sw
Date:			29 November 2006
Author:			Scott Wallace

Fairly extensive cleanups and improvements to the EventRecordingSpace, now called the Event Theate.

=== 1130deactivateSound-bf.cs ===
Change Set:		deactivateSound-bf
Date:			24 November 2006
Author:			Bert Freudenberg

Deactivate sound while not active. Activation/deactivation commands are sent from Sugar activity when the focus changes. Requires SIGIO fix for vm-sound-ALSA module.

=== 1129interiorFlapFix-sw.cs ===
Change Set:		interiorFlapFix-sw
Date:			22 November 2006
Author:			Scott Wallace

Fixes a bug that could make interior flap tabs initially nonresponsive to a click.

=== 1127lessoftenupdate.cs ===
Change Set:		lessoftenupdate
Date:			16 November 2006
Author:			Yoshiki Ohshima

Reduce CPU usage by Kedama when nothing is changed.

=== 1126renamePatchNov16-yo.cs ===
Change Set:		renamePatchNov16-yo
Date:			15 November 2006
Author:			Yoshiki Ohshima

Allows renaming of the default patch variable.

=== 1125OLPCWsConflicts-yo.cs ===
Change Set:		OLPCWsConflicts-yo
Date:			15 November 2006
Author:			Yoshiki Ohshima

Resolves some conflicts with World Stethoscope.

=== 1124Ws20051002.cs ===
Change Set:		Ws20051002
Date:			2 October 2005
Author:			Kazuhiro Abe and Tetsuya Hayashi

(Load ja_Ws20050528.translation before this file if you need Japanese wordings).

* World-Stethoscope software module
See http://swikis.ddo.jp/WorldStethoscope/.

This change set is depend on Squeak Nihong7 update #98.
- arranged by Takashi Yamamiya for Squeak Nihong7 update #98.
- arranged by Kazuhiro Abe for Squeakland 3.8-05 #487.


=== 1123initialFITBselection-yo.cs ===
Change Set:		initialFITBselection-yo
Date:			14 November 2006
Author:			Yoshiki Ohshima

Select the content of FillInTheBlank upon creation.

=== 1122lazyViewerRenameFix-yo.cs ===
Change Set:		lazyViewerRenameFix-yo
Date:			14 November 2006
Author:			Yoshiki Ohshima

Two category viewers on the same category may be created.

=== 1121hideAllPlayersBug-sw.cs ===
Change Set:		hideAllPlayersBug-sw
Date:			10 November 2006
Author:			Scott Wallace

Fixes bug in the playfield-options command 'hide all players' (which means 'Hide all Viewers') which could leave artifacts on the screen if a viewer flap were open at the time of invocation.

=== 1120voiceoverEtc-sw.cs ===
Change Set:		voiceoverEtc-sw
Date:			11 November 2006
Author:			Scott Wallace

Advances in recording & playback with EventRecordingSpace, including:
* Allows voiceover to be recorded (or re-recorded) after the event recording is already made.
*  Playback-space invocation can specify auto-start and/or auto-dismiss.
* Offers two additional playback-invoking-buttons of the sort requested by Alan, suitable for placing inside tutorial book pages; one is a 0.3 scale-down of the initial state of the animation, emblazoned with the word 'HINT' before it has been invoked; after being and run and then dismissed, it assumes a larger form showing a shrunk-down version of the final state of the event-recorded sequence.
* Warning is presented before blithely dismissing a recording for which no playback button has ever been obtained.

=== 1119propertySheetReplay-sw.cs ===
Change Set:		propertySheetReplay-sw
Date:			11 November 2006
Author:			Scott Wallace

When a graphical property sheet is brought up (via the magenta halo handle) on a morph that is inside an event-recording space, it is now positioned relative to the recording space, thus greatly increasing the probability that a later replay of the sequence, even in a different part of the screen, will still work correctly.

=== 1117scriptorInval-kfr.cs ===
Change Set:		scriptorInval-kfr
Date:			7 November 2006
Author:			Karl Ramberg

Avoid spurious invalidation while a phrase tile is being dragged over a ScriptEditorMorph.

=== 1116FillInTheBlank-tak.cs ===
Change Set:		RemakeFillInTheBlank-tak
Date:			9 November 2006
Author:			Takashi Yamamiya

http://dev.laptop.org/ticket/211

Fix the look of FillInTheBlank widget.


=== 1115V4LPluginRename-yo.cs ===
Change Set:		V4LPluginRename-yo
Date:			8 November 2006
Author:			Diego Gomez Deck and Yoshiki Ohshima

Rename V4LPlugin to VideoForLinuxPlugin.

=== 1114Video4Squeak-dgd.cs ===
Change Set:		Video4Squeak-dgd
Date:			3 November 2006
Author:			Diego Gomez Deck <DiegoGomezDeck@consultar.com>



=== 1113GettextSupport2-tak.cs ===
Change Set:		GettextSupport2-tak
Date:			8 November 2006
Author:			Takashi Yamamiya

Better gettext support.

- Multi-line text.
- \\n or \\\\n problem by a bug in gettext importer is clean up by the postscript.
- Resolved a bug by \ quotation.
- Support code to collect phrases.

** useful expressions **

To collect phrases, do it; 
TranslatedReceiverFinder new stringReceivers.

To browse non-literal receivers, (we have to eliminate them and use a literal as a receiver of #translated because the system have to know where are candidate phrases).
TranslatedReceiverFinder browseNonLiteralReceivers.


=== 1112pickableBook-yo.cs ===
Change Set:		pickableBook-yo
Date:			7 November 2006
Author:			Yoshiki Ohshima

Make BookMorph draggable at the title.  This change set also increases the font size in the menu title.  (There may be a better design, though).

=== 1111GettextSupport-tak.cs ===
Change Set:		GettextSupport-tak
Date:			31 October 2006
Author:			Takashi Yamamiya, Alberto Berti

The first trial for GetText support.

This changeset results from;
- http://lists.squeakfoundation.org/pipermail/squeak-dev/2006-March/101143.html
- http://www.languagegame.org:8080/ggame/17

* fastLanguageEditor-tak.cs
Add instance variable 'translations' and 'untranslated' as cache for
speed up the UI operation.

* GetTextUTF8-tak.cs
Gettext support with UTF-8 for LanguageEditor.
This source code is based on SqueakSmallLand38-0324-1233.image.

* fixGetTextEscape-tak.cs
- fix a bug that \ becomes \\\ through gettext export and import.
- add unit test for basic function in LanguageEditor.



=== 1110olpc1-1104-1108.cs ===
Change Set:		olpc1-1104-1108
Date:			30 October 2006
Author:			Takashi Yamamiya

This change set is from OLPC1.0 update stream.

* 1104SpTransForSplash3-tak.cs
All (file list) and Recent (etoys launcher) are now opened the previous project of the Welcome project.

* 1107prefDir-bf.cs
Look in image path for preferences

* 1108EnterNew-tak.cs
In New button, make and enter the new project instead of just make.


=== 1109playbackStop-tk.cs ===
Change Set:		playbackStop-tk
Date:			28 October 2006
Author:			Ted Kaehler

Inside an EventRecordingSpace, stop playback when the user clicks for any reason.  

I would like to also stop when any key is pressed, but I can't figure out how to do this.  If the user types, he has usually clicked where he wants to type, and that will stop the playback.




=== 1106authTools-sw.cs ===
Change Set:		authTools-sw
Date:			26 October 2006
Author:			Scott Wallace

If the eToyFriendly preference is turned off, the authoring tool menu will now be shown in its 'classic' full form, which has eight more items than the short olpc form, including some useful, even indispensable, functions not otherwise available.

=== 1105eventRecFramework-sw.cs ===
Change Set:		eventRecFramework-sw
Date:			25 October 2006
Author:			Scott Wallace

Provides a framework for using the EventRecorder to make little 'event movies' containing snippets of tutorial.  The focus here is to to provide as  reliable environment as possible,without most of the hazards that befall event-recorded recreations, by providing a confined staging area, with its own interior supplies-flap, navigator, painting area, and viewer flaps, so that many tutorials can be created without ever needing to go outside the bounds of the staging area.  Such a capture has a higher likelihood of being adequately replicable at playback time, on a variety of screen resolutions etc, because the recording carries its own environment with it.

To record:

1. Obtain an Event Recording Framework from the Objects catalog, or the desktop's 'open' menu.
2. Add or delete flaps to it as desired, using the menu,
3. Resize the tool so that the 'content area' is exactly the size you want it to be when the movie is played.
4. Set up the initial conditions -- e.g., paint the background, add some explanatory text -- for the movie.
5. Hit the Record button.
6. Do whatever it is that your event-movie is supposed to do.
7. Hit ESC when done.
8. Rewind and play to see if satisfied.  If not, re-record.
9. Edit the string 'Untitled' into the caption you want for your event-movie.
10. Hit the Publish button to obtain a button.
11. Place the resulting event-playback button wherever you wish.  This is the end product of the exercise.

To play back:

1. Click on an event-playback button of the sort described above.
2. A playback tool opens.  Its initial state is as defined in step 4 of the recording session.
3. You can reposition the tool as desired, using cmd-drag.  Do not Resize it  [note that the grow halo handle is disabled].

=== 1103firstTwoOhUpdate-sw.cs ===
Change Set:		firstTwoOhUpdate-sw
Date:			24 October 2006
Author:			Scott Wallace

Constitutes the initial update for OLPC2.0.

A few minor debugging improvements...
* For MorphExtensionPlus, fleshes out  #printOn: and #sortedPropertyNames, and adds a class comment.
* In following property values of a morph via 'inspect element' from the inspect-list menu of an inspector when the extension is selected, the newly-launched inspector now identifies the property and the morph from whence its inspectee was obtained.
* Bulletproofs execution of the 'inspect element' menu command in an Inspector against the case where there are no overridden properties in the morph to offer -- formerly this case had resulted in an error.
